package com.hjsoft.integration.zxbc;

package ..deTemp.1747043240876;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hjsoft.base.basic.BasicPOJO;
import com.hjsoft.base.basic.RpcBasicService;
import com.hjsoft.base.pose.PosPOJO;
import com.hjsoft.base.pose.RpcPosService;
import com.hjsoft.base.staff.RpcStaffService;
import com.hjsoft.base.staff.StaffEntity;
import com.hjsoft.base.staff.event.StaffPartJobChangedEvent;
import com.hjsoft.base.staff.event.UpdateOrgDataPair;
import com.hjsoft.base.staff.event.UpdateOrgPair;
import com.hjsoft.base.staff.event.UpdatePair;
import com.hjsoft.base.staff.event.UpdatePartJobPair;
import com.hjsoft.base.staff.parttimejob.PartTimeJob;
import com.hjsoft.base.staff.parttimejob.RpcPartTimeJobService;
import com.hjsoft.base.structure.DeptPOJO;
import com.hjsoft.base.structure.RpcDeptService;
import com.hjsoft.base.structure.RpcStructureService;
import com.hjsoft.base.structure.StructurePOJO;
import com.hjsoft.frame.role.RoleEntity;
import com.hjsoft.frame.role.RpcRoleService;
import com.hjsoft.frame.security.ShiroUser;
import com.hjsoft.frame.user.RpcUserService;
import com.hjsoft.frame.user.UserEntity;
import com.hjsoft.frame.userrole.RpcUserRoleService;
import com.hjsoft.frame.userrole.UserRoleEntity;
import com.hjsoft.hjlicence.RpcLicenceService;
import com.hjsoft.hjlicence.ValidResult;
import com.hjsoft.integration.CommonService;
import com.hjsoft.integration.IntegrationAdaptable;
import com.hjsoft.integration.IntegrationCustomEntity;
import com.hjsoft.integration.IntegrationEntity;
import com.hjsoft.integration.RpcApplicationService;
import com.hjsoft.integration.acceptdataInfo.RecordDataEntity;
import com.hjsoft.integration.acceptdataInfo.RecordDataService;
import com.hjsoft.integration.acceptdataInfo.RecordDetailEntity;
import com.hjsoft.integration.acceptdataInfo.RecordDetailService;
import com.hjsoft.integration.dingdingtalk.service.DingtalkService;
import com.hjsoft.integration.exception.InteConfirmException;
import com.hjsoft.integration.hcm.support.OrgUtils;
import com.hjsoft.integration.view.ReportLineData;
import com.hjsoft.integration.zgtj.pojo.entity.ZgtjOrgMatchEntity;
import com.hjsoft.integration.zgtj.service.ZgtjService;
import com.hjsoft.integration.zxbc.BtdAccessToken;
import com.hjsoft.integration.zxbc.BtdSsoUserInfo;
import com.hjsoft.integration.zxbc.support.StaffSuppose;
import com.hjsoft.integration.zxbc.support.StrSuppose;
import com.hjsoft.recycle.RecyclePOJO;
import com.hjsoft.recycle.RpcRecycleService;
import com.hjsoft.tenant.TenantEntity;
import com.hjsoft.tenant.taskormessage.UserTaskEntity;
import com.rap.common.exception.ServiceException;
import com.rap.common.net.NetBrowser;
import com.rap.common.utils.BatchUtils;
import com.rap.common.utils.CharacterToSpell;
import com.rap.common.utils.CollectionHelper;
import com.rap.common.utils.EntityUtil;
import com.rap.common.utils.Identities;
import com.rap.common.utils.Jsons;
import com.rap.common.utils.Randomizer;
import com.rap.common.utils.Strings;
import java.io.IOException;
import java.security.MessageDigest;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.connection.jedis.JedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class ZxbcService implements IntegrationAdaptable {
  private Logger logger = LoggerFactory.getLogger(getClass());
  
  @Autowired
  private NetBrowser browser;
  
  @Autowired
  private RpcLicenceService rpcLicenceService;
  
  @Autowired
  private RpcStructureService structureService;
  
  @Autowired
  private CommonService commonService;
  
  @Autowired
  private RpcUserService userService;
  
  @Autowired
  private RpcPartTimeJobService partTimeJobService;
  
  @Autowired
  private RpcRoleService roleService;
  
  @Autowired
  private DingtalkService dingtalkService;
  
  @Autowired
  private RpcApplicationService applicationService;
  
  @Autowired
  private ZgtjService zgtjService;
  
  @Autowired
  private RpcBasicService basicService;
  
  @Autowired
  private RpcRecycleService recycleService;
  
  @Autowired
  private RpcDeptService deptService;
  
  @Autowired
  private RpcPosService posService;
  
  @Autowired
  private RpcStaffService staffService;
  
  @Autowired
  private RpcUserRoleService userRoleService;
  
  @Autowired
  private RecordDetailService recordDetailService;
  
  @Autowired
  private RecordDataService recordDataService;
  
  @Autowired
  private JedisConnectionFactory redisFactory;
  
  private RedisTemplate<String, String> tokenCache;
  
  public String getAppKey() {
    return "zxbc";
  }
  
  @PostConstruct
  private void init() {
    this.tokenCache = new RedisTemplate();
    this.tokenCache.setConnectionFactory((RedisConnectionFactory)this.redisFactory);
    this.tokenCache.setKeySerializer((RedisSerializer)new StringRedisSerializer());
    this.tokenCache.setValueSerializer((RedisSerializer)new StringRedisSerializer());
    this.tokenCache.afterPropertiesSet();
  }
  
  public void cache(String key, Object value) {
    this.tokenCache.opsForValue().set(key, Jsons.jsonString(value));
  }
  
  public <R> R getFromCache(String key, Class<R> objType) {
    String v = (String)this.tokenCache.opsForValue().get(key);
    if (StringUtils.isBlank(v))
      return null; 
    return (R)Jsons.objcet(v, objType);
  }
  
  public BtdAccessToken getLoginAccessToken(String apiDomain, String code, String clientId, String clientSecret, String redirectUri) {
    String url = apiDomain + "user_center/api/public/sso/oauth/token";
    Map<String, Object> entity = new HashMap<>();
    entity.put("client_id", clientId);
    entity.put("client_secret", clientSecret);
    entity.put("code", code);
    entity.put("redirect_uri", redirectUri);
    entity.put("grant_type", "authorization_code");
    entity.put("scope", "all");
    BtdAccessToken token = (BtdAccessToken)this.browser.executeFormPost(url, entity, BtdAccessToken.class);
    return token;
  }
  
  public List<ReportLineData> getReportLine(IntegrationCustomEntity integration) {
    List<ReportLineData> reportLineData = new ArrayList<>();
    int page = 1;
    while (true) {
      Map<String, Object> mapPage = new HashMap<>();
      mapPage.put("page_size", "2000");
      mapPage.put("page_index", Integer.valueOf(page));
      List list = new ArrayList();
      mapPage.put("query_criteria", list);
      Map<Object, Object> sort = new HashMap<>();
      sort.put("模型字段编号", "asc/desc");
      Map<Object, Object> mapasc = new HashMap<>();
      mapasc.put("workNumber", "asc");
      mapPage.put("sort_criteria", mapasc);
      Map<String, String> configs = integration.getConfObj();
      String apiDomain = configs.get("url");
      String clientId = configs.get("clientId");
      String clientSecret = configs.get("clientSecret");
      String tenantIdWai = configs.get("tenantIdWai");
      String svcCode = configs.get("reportsvcCode");
      String reportUrl = configs.get("reportUrl");
      String reportDataCode = configs.get("reportDataCode");
      Long currTime = Long.valueOf(System.currentTimeMillis());
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
      String timestamp = simpleDateFormat.format(new Date(currTime.longValue()));
      Map<String, Object> mapRequestBean = new HashMap<>();
      Map<String, Object> map = new HashMap<>();
      map.put("tenant_id", tenantIdWai);
      map.put("user_id", "sysadmin");
      map.put("svc_code", svcCode);
      Map<String, Object> queryMap = new HashMap<>();
      queryMap.put("query", mapPage);
      map.put("exe_svc_param", queryMap);
      map.put("data_code", reportDataCode);
      String bizParams = JSON.toJSONString(map);
      mapRequestBean.put("biz_params", bizParams);
      mapRequestBean.put("sign", getSign(clientSecret, timestamp, bizParams));
      mapRequestBean.put("timestamp", timestamp);
      mapRequestBean.put("app_id", clientId);
      mapRequestBean.put("tenant_id", tenantIdWai);
      String url = apiDomain + reportUrl;
      Map<String, String> headers = new HashMap<>();
      ReportLineData reportLineDataNew = (ReportLineData)this.browser.executePost(url, mapRequestBean, headers, ReportLineData.class);
      reportLineData.add(reportLineDataNew);
      if (reportLineDataNew.getData().getResult().getTotal().intValue() / 2000 < page)
        break; 
      page++;
    } 
    return reportLineData;
  }
  
  public BtdSsoUserInfo getLoginInfo(String apiDomain, Map<String, String> mapRequestBean, String clientId, String clientSecret, String redirectUri) {
    String url = apiDomain + "ego_base_info/v1/open/sso/service/checkCode";
    Map<String, String> headers = new HashMap<>();
    BtdSsoUserInfo loginInfo = (BtdSsoUserInfo)this.browser.executePost(url, mapRequestBean, headers, BtdSsoUserInfo.class);
    return loginInfo;
  }
  
  public static String getSign(String secret, String timestamp, String bizParams) {
    String signBeforeStr = secret + timestamp + bizParams;
    try {
      byte[] btInput = signBeforeStr.getBytes("utf-8");
      MessageDigest mdInst = MessageDigest.getInstance("MD5");
      mdInst.update(btInput);
      byte[] md = mdInst.digest();
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < md.length; i++) {
        int val = md[i] & 0xFF;
        if (val < 16)
          sb.append("0"); 
        sb.append(Integer.toHexString(val));
      } 
      return sb.toString();
    } catch (Exception e) {
      throw new InteConfirmException("", "MD5Encoder异常：" + e.getMessage());
    } 
  }
  
  public List<UserTaskEntity> sendUseTasks(List<UserTaskEntity> tasks, IntegrationEntity integration, TenantEntity targetTenant) {
    return null;
  }
  
  public List<UserTaskEntity> sendUseTaskDealeds(List<UserTaskEntity> tasks, IntegrationEntity integration, TenantEntity targetTenant) {
    return null;
  }
  
  public void processCustomParamsBeforeSave(IntegrationCustomEntity newIntegration, IntegrationCustomEntity oldIntegration) {}
  
  public List<ReportLineData> getStr(IntegrationCustomEntity integration) {
    List<ReportLineData> reportLineData = new ArrayList<>();
    int page = 1;
    while (true) {
      Map<String, Object> mapPage = new HashMap<>();
      mapPage.put("page_size", "2000");
      mapPage.put("page_index", Integer.valueOf(page));
      List list = new ArrayList();
      mapPage.put("query_criteria", list);
      Map<Object, Object> sort = new HashMap<>();
      sort.put("模型字段编号", "asc/desc");
      Map<Object, Object> mapasc = new HashMap<>();
      mapasc.put("orgId", "asc");
      mapPage.put("sort_criteria", mapasc);
      Map<String, String> configs = integration.getConfObj();
      String apiDomain = configs.get("url");
      String clientId = configs.get("clientId");
      String clientSecret = configs.get("clientSecret");
      String tenantIdWai = configs.get("tenantIdWai");
      String svcCode = configs.get("strsvcCode");
      String reportUrl = configs.get("strUrl");
      String reportDataCode = configs.get("strDataCode");
      Long currTime = Long.valueOf(System.currentTimeMillis());
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
      String timestamp = simpleDateFormat.format(new Date(currTime.longValue()));
      Map<String, Object> mapRequestBean = new HashMap<>();
      Map<String, Object> map = new HashMap<>();
      map.put("tenant_id", tenantIdWai);
      map.put("user_id", "sysadmin");
      map.put("svc_code", svcCode);
      Map<String, Object> queryMap = new HashMap<>();
      queryMap.put("query", mapPage);
      map.put("exe_svc_param", queryMap);
      map.put("data_code", reportDataCode);
      String bizParams = JSON.toJSONString(map);
      mapRequestBean.put("biz_params", bizParams);
      mapRequestBean.put("sign", getSign(clientSecret, timestamp, bizParams));
      mapRequestBean.put("timestamp", timestamp);
      mapRequestBean.put("app_id", clientId);
      mapRequestBean.put("tenant_id", tenantIdWai);
      String url = apiDomain + reportUrl;
      Map<String, String> headers = new HashMap<>();
      ReportLineData reportLineDataNew = (ReportLineData)this.browser.executePost(url, mapRequestBean, headers, ReportLineData.class);
      reportLineData.add(reportLineDataNew);
      if (reportLineDataNew.getData().getResult().getTotal().intValue() / 2000 < page)
        break; 
      page++;
    } 
    return reportLineData;
  }
  
  public List<ReportLineData> getDept(IntegrationCustomEntity integration) {
    List<ReportLineData> reportLineData = new ArrayList<>();
    int page = 1;
    while (true) {
      Map<String, Object> mapPage = new HashMap<>();
      mapPage.put("page_size", "2000");
      mapPage.put("page_index", Integer.valueOf(page));
      List list = new ArrayList();
      mapPage.put("query_criteria", list);
      Map<Object, Object> sort = new HashMap<>();
      sort.put("模型字段编号", "asc/desc");
      Map<Object, Object> mapasc = new HashMap<>();
      mapasc.put("orgId", "asc");
      mapPage.put("sort_criteria", mapasc);
      Map<String, String> configs = integration.getConfObj();
      String apiDomain = configs.get("url");
      String clientId = configs.get("clientId");
      String clientSecret = configs.get("clientSecret");
      String tenantIdWai = configs.get("tenantIdWai");
      String svcCode = configs.get("deptsvcCode");
      String reportUrl = configs.get("deptUrl");
      String reportDataCode = configs.get("deptDataCode");
      Long currTime = Long.valueOf(System.currentTimeMillis());
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
      String timestamp = simpleDateFormat.format(new Date(currTime.longValue()));
      Map<String, Object> mapRequestBean = new HashMap<>();
      Map<String, Object> map = new HashMap<>();
      map.put("tenant_id", tenantIdWai);
      map.put("user_id", "sysadmin");
      map.put("svc_code", svcCode);
      Map<String, Object> queryMap = new HashMap<>();
      queryMap.put("query", mapPage);
      map.put("exe_svc_param", queryMap);
      map.put("data_code", reportDataCode);
      String bizParams = JSON.toJSONString(map);
      mapRequestBean.put("biz_params", bizParams);
      mapRequestBean.put("sign", getSign(clientSecret, timestamp, bizParams));
      mapRequestBean.put("timestamp", timestamp);
      mapRequestBean.put("app_id", clientId);
      mapRequestBean.put("tenant_id", tenantIdWai);
      String url = apiDomain + reportUrl;
      Map<String, String> headers = new HashMap<>();
      ReportLineData reportLineDataNew = (ReportLineData)this.browser.executePost(url, mapRequestBean, headers, ReportLineData.class);
      reportLineData.add(reportLineDataNew);
      if (reportLineDataNew.getData().getResult().getTotal().intValue() / 2000 < page)
        break; 
      page++;
    } 
    return reportLineData;
  }
  
  public List<ReportLineData> getPos(IntegrationCustomEntity integration) {
    List<ReportLineData> reportLineData = new ArrayList<>();
    int page = 1;
    while (true) {
      Map<String, Object> mapPage = new HashMap<>();
      mapPage.put("page_size", "2000");
      mapPage.put("page_index", Integer.valueOf(page));
      List list = new ArrayList();
      mapPage.put("query_criteria", list);
      Map<Object, Object> sort = new HashMap<>();
      sort.put("模型字段编号", "asc/desc");
      Map<Object, Object> mapasc = new HashMap<>();
      mapasc.put("posId", "asc");
      mapPage.put("sort_criteria", mapasc);
      Map<String, String> configs = integration.getConfObj();
      String apiDomain = configs.get("url");
      String clientId = configs.get("clientId");
      String clientSecret = configs.get("clientSecret");
      String tenantIdWai = configs.get("tenantIdWai");
      String svcCode = configs.get("possvcCode");
      String reportUrl = configs.get("posUrl");
      String reportDataCode = configs.get("posDataCode");
      Long currTime = Long.valueOf(System.currentTimeMillis());
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
      String timestamp = simpleDateFormat.format(new Date(currTime.longValue()));
      Map<String, Object> mapRequestBean = new HashMap<>();
      Map<String, Object> map = new HashMap<>();
      map.put("tenant_id", tenantIdWai);
      map.put("user_id", "sysadmin");
      map.put("svc_code", svcCode);
      Map<String, Object> queryMap = new HashMap<>();
      queryMap.put("query", mapPage);
      map.put("exe_svc_param", queryMap);
      map.put("data_code", reportDataCode);
      String bizParams = JSON.toJSONString(map);
      mapRequestBean.put("biz_params", bizParams);
      mapRequestBean.put("sign", getSign(clientSecret, timestamp, bizParams));
      mapRequestBean.put("timestamp", timestamp);
      mapRequestBean.put("app_id", clientId);
      mapRequestBean.put("tenant_id", tenantIdWai);
      String url = apiDomain + reportUrl;
      Map<String, String> headers = new HashMap<>();
      ReportLineData reportLineDataNew = (ReportLineData)this.browser.executePost(url, mapRequestBean, headers, ReportLineData.class);
      reportLineData.add(reportLineDataNew);
      if (reportLineDataNew.getData().getResult().getTotal().intValue() / 2000 < page)
        break; 
      page++;
    } 
    return reportLineData;
  }
  
  public List<ReportLineData> getStaff(IntegrationCustomEntity integration) {
    List<ReportLineData> reportLineData = new ArrayList<>();
    int page = 1;
    while (true) {
      Map<String, Object> mapPage = new HashMap<>();
      mapPage.put("page_size", "2000");
      mapPage.put("page_index", Integer.valueOf(page));
      List list = new ArrayList();
      mapPage.put("query_criteria", list);
      Map<Object, Object> sort = new HashMap<>();
      sort.put("模型字段编号", "asc/desc");
      Map<Object, Object> mapasc = new HashMap<>();
      mapasc.put("autoid", "asc");
      mapPage.put("sort_criteria", mapasc);
      Map<String, String> configs = integration.getConfObj();
      String apiDomain = configs.get("url");
      String clientId = configs.get("clientId");
      String clientSecret = configs.get("clientSecret");
      String tenantIdWai = configs.get("tenantIdWai");
      String svcCode = configs.get("staffsvcCode");
      String reportUrl = configs.get("staffUrl");
      String reportDataCode = configs.get("staffDataCode");
      Long currTime = Long.valueOf(System.currentTimeMillis());
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
      String timestamp = simpleDateFormat.format(new Date(currTime.longValue()));
      Map<String, Object> mapRequestBean = new HashMap<>();
      Map<String, Object> map = new HashMap<>();
      map.put("tenant_id", tenantIdWai);
      map.put("user_id", "sysadmin");
      map.put("svc_code", svcCode);
      Map<String, Object> queryMap = new HashMap<>();
      queryMap.put("query", mapPage);
      map.put("exe_svc_param", queryMap);
      map.put("data_code", reportDataCode);
      String bizParams = JSON.toJSONString(map);
      mapRequestBean.put("biz_params", bizParams);
      mapRequestBean.put("sign", getSign(clientSecret, timestamp, bizParams));
      mapRequestBean.put("timestamp", timestamp);
      mapRequestBean.put("app_id", clientId);
      mapRequestBean.put("tenant_id", tenantIdWai);
      String url = apiDomain + reportUrl;
      Map<String, String> headers = new HashMap<>();
      ReportLineData reportLineDataNew = (ReportLineData)this.browser.executePost(url, mapRequestBean, headers, ReportLineData.class);
      reportLineData.add(reportLineDataNew);
      if (reportLineDataNew.getData().getResult().getTotal().intValue() / 2000 < page)
        break; 
      page++;
    } 
    return reportLineData;
  }
  
  @Transactional
  public void autoSync(List<StrSuppose> strSupposes, List<StructurePOJO> allHjStructures, UserEntity tadmin, IntegrationCustomEntity integration, RecordDataEntity recordDataStr, RecordDataEntity recordDataStaff) throws IOException, InterruptedException, ServiceException, ParseException {
    String tenantId = tadmin.getTenantId();
    ValidResult vr = this.rpcLicenceService.validStaffAmount(tenantId);
    this.logger.info("zxbc update staff licence authed ：{}", vr);
    int authedCount = vr.getAddableAmount();
    Date nowDate = new Date();
    DateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    Date endDate = format.parse("9999-01-01 00:00:00");
    this.logger.info("strSupposes {}", strSupposes);
    List<ReportLineData> staffZxbc = getStaff(integration);
    List<Map<String, Object>> allStaffMaps = new ArrayList<>();
    for (ReportLineData str : staffZxbc) {
      List<Map<String, Object>> maps = str.getData().getResult().getValue();
      allStaffMaps.addAll(maps);
    } 
    List<StaffSuppose> staffSupposes = JSONObject.parseArray(JSON.toJSONString(allStaffMaps), StaffSuppose.class);
    Map<String, StrSuppose> zxbcdIAndDeptDto = CollectionHelper.mapDict(strSupposes, a -> a.getOrgId());
    String zxbcRootId = null;
    for (StrSuppose strSuppose : strSupposes) {
      if ("0".equals(strSuppose.getParentid())) {
        zxbcRootId = strSuppose.getOrgId();
        break;
      } 
    } 
    this.logger.info("zxbcRootId{}", zxbcRootId);
    StructurePOJO rootStructure = this.structureService.findByTopOrgCode(tenantId);
    if (!Strings.equals(rootStructure.getOrgNum(), String.valueOf(zxbcRootId))) {
      rootStructure.setOrgNum(String.valueOf(zxbcRootId));
      this.structureService.save(rootStructure);
    } 
    List<RecyclePOJO> recyclePOJOS = this.recycleService.findAllByTenantId(tadmin.getTenantId());
    Map<String, RecyclePOJO> recyclePOJOMap = CollectionHelper.mapDict(recyclePOJOS, recyclePOJO -> recyclePOJO.getObjectId());
    List<BasicPOJO> allUnits = this.commonService.findByTenantIdInRnageAll(tenantId);
    List<DeptPOJO> allDepts = this.commonService.findDeptsByTenantIdAll(tenantId);
    List<PosPOJO> allPos = this.commonService.findPosByTenantIdAll(tenantId);
    List<StaffEntity> allStaffs = this.commonService.findStaffsByTenantIdAll(tenantId);
    List<PartTimeJob> allPartTimeJobs = this.commonService.findPartTimeJobByTenantIdAll(tenantId);
    List<StructurePOJO> addStructures = new ArrayList<>();
    List<BasicPOJO> addUnits = new ArrayList<>();
    List<DeptPOJO> addDepts = new ArrayList<>();
    List<PosPOJO> addPos = new ArrayList<>();
    List<StructurePOJO> updateStructures = new ArrayList<>();
    List<BasicPOJO> updateUnits = new ArrayList<>();
    List<DeptPOJO> updateDepts = new ArrayList<>();
    List<PosPOJO> updatePos = new ArrayList<>();
    List<StructurePOJO> unMatchStructures = new ArrayList<>();
    List<StaffEntity> addStaffs = new ArrayList<>();
    List<PartTimeJob> addPartTimeJobs = new ArrayList<>();
    List<UserEntity> addUsers = new ArrayList<>();
    List<UserRoleEntity> addUserRoles = new ArrayList<>();
    List<StaffEntity> updateStaffs = new ArrayList<>();
    List<PartTimeJob> updatePartTimeJobs = new ArrayList<>();
    List<StaffEntity> deleteStaffs = new ArrayList<>();
    List<PartTimeJob> deletePartTimeJobs = new ArrayList<>();
    List<PartTimeJob> reholdPartTimeJobs = new ArrayList<>();
    List<UpdatePair> updateStaffPublishList = new ArrayList<>();
    List<UpdatePair> updateStaffTypeOnePublishList = new ArrayList<>();
    List<UpdatePartJobPair> updatePartTimeJobPublishList = new ArrayList<>();
    List<UpdateOrgPair> orgInfoChangedPublishList = new ArrayList<>();
    List<UpdateOrgDataPair> orgDataChangedPublishList = new ArrayList<>();
    autoSyncAddStr(tadmin, allHjStructures, allUnits, strSupposes, addStructures, addUnits, updateStructures, allDepts, allPos, addDepts, addPos, nowDate, endDate);
    allDepts.addAll(addDepts);
    allPos.addAll(addPos);
    this.logger.info("addUnits size{}", Integer.valueOf(addUnits.size()));
    autoSyncUpdateStr(recyclePOJOMap, allHjStructures, allUnits, allDepts, allPos, allStaffs, allPartTimeJobs, strSupposes, updateStructures, updateStructures, updateUnits, updateDepts, updatePos, updateStaffs, updatePartTimeJobs, updateStaffPublishList, updatePartTimeJobPublishList, orgInfoChangedPublishList);
    autoSyncTransferStr(allHjStructures, allUnits, allDepts, allPos, allStaffs, allPartTimeJobs, strSupposes, updateStructures, updateStructures, updateUnits, updateDepts, updatePos, updateStaffs, updatePartTimeJobs, updateStaffTypeOnePublishList, updatePartTimeJobPublishList, orgDataChangedPublishList);
    autoSyncDeleteStr(allHjStructures, strSupposes, unMatchStructures);
    autoSyncAddStaff(tadmin, allHjStructures, allUnits, allDepts, allStaffs, allPartTimeJobs, staffSupposes, addStaffs, addPartTimeJobs, addUsers, addUserRoles);
    autoSyncUpdateStaff(addUsers, addUserRoles, recyclePOJOMap, tadmin, allHjStructures, allUnits, allDepts, allPos, allStaffs, allPartTimeJobs, staffSupposes, updateStaffs, addPartTimeJobs, reholdPartTimeJobs, deletePartTimeJobs, updateStaffPublishList, updateStaffTypeOnePublishList);
    autoSyncDeleteStaff(allStaffs, staffSupposes, deleteStaffs, recyclePOJOMap);
    addStructures.stream().peek(s -> s.setStartDate(nowDate)).peek(s -> s.setCreateTs(nowDate)).peek(s -> s.setEndDate(endDate)).collect(Collectors.toList());
    addUnits.stream().peek(s -> s.setStartDate(nowDate)).peek(s -> s.setCreateTs(nowDate)).peek(s -> s.setEndDate(endDate)).collect(Collectors.toList());
    addDepts.stream().peek(s -> s.setStartDate(nowDate)).peek(s -> s.setCreateTs(nowDate)).peek(s -> s.setEndDate(endDate)).collect(Collectors.toList());
    addPos.stream().peek(s -> s.setStartDate(nowDate)).peek(s -> s.setCreateTs(nowDate)).peek(s -> s.setEndDate(endDate)).collect(Collectors.toList());
    addStaffs.stream().peek(s -> s.setCreateTs(nowDate)).collect(Collectors.toList());
    addPartTimeJobs.stream().peek(s -> s.setCreateTs(nowDate)).peek(s -> s.setStartDate(nowDate)).collect(Collectors.toList());
    addUsers.stream().peek(s -> s.setCreateTs(nowDate)).collect(Collectors.toList());
    addUserRoles.stream().peek(s -> s.setCreateTs(nowDate)).collect(Collectors.toList());
    updateStructures.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    updateUnits.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    updateDepts.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    updatePos.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    updateStaffs.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    updatePartTimeJobs.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    deleteStaffs.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    deletePartTimeJobs.stream().peek(s -> s.setModifyTs(nowDate)).collect(Collectors.toList());
    List<String> deleteStructureIdList = CollectionHelper.extractToList(unMatchStructures, u -> u.getOrgId());
    List<String> notAllowDeleteStructureIdList = new ArrayList<>();
    judgeDeleteStr(deleteStructureIdList, notAllowDeleteStructureIdList, tenantId);
    List<String> deleteStaffIdList = CollectionHelper.extractToList(deleteStaffs, d -> d.getUuid());
    judgeDeleteStaff(deleteStaffIdList, tenantId);
    List<StaffEntity> deleteStaffList = CollectionHelper.filter(deleteStaffs, d -> deleteStaffIdList.contains(d.getUuid()));
    BatchUtils.excuteBatch(10, addStructures, a -> addStruncture(a));
    BatchUtils.excuteBatch(100, addUnits, a -> addBasic(a));
    BatchUtils.excuteBatch(100, addDepts, a -> adddept(a));
    BatchUtils.excuteBatch(100, addPos, a -> addPos(a));
    List<StructurePOJO> newUpdateStructures = CollectionHelper.distinct(updateStructures, (a, b) -> a.getUuid().equals(b.getUuid()));
    Map<String, StructurePOJO> uuidAndStructurePOJO = CollectionHelper.mapDict(newUpdateStructures, a -> a.getUuid());
    List<StructurePOJO> tempList = CollectionHelper.filter(newUpdateStructures, a -> (uuidAndStructurePOJO.get(a.getParentId()) == null));
    while (tempList.size() != 0) {
      BatchUtils.excuteBatch(100, tempList, ns -> this.structureService.saveOnlyNew(ns));
      List<String> uuidList = CollectionHelper.extractToList(tempList, f -> f.getUuid());
      tempList.clear();
      tempList = CollectionHelper.filter(newUpdateStructures, a -> uuidList.contains(a.getParentId()));
    } 
    BatchUtils.excuteBatch(100, updateUnits, ns -> this.basicService.saveOnly(ns));
    BatchUtils.excuteBatch(100, updateDepts, ns -> this.deptService.saveOnly(ns));
    BatchUtils.excuteBatch(100, updatePos, ns -> this.posService.saveOnly(ns));
    BatchUtils.excuteBatch(100, deleteStructureIdList, dt -> this.structureService.deleteOrg(dt, tadmin.getTenant(), tadmin));
    BatchUtils.excuteBatch(100, addPartTimeJobs, a -> this.partTimeJobService.saveOnly(a));
    BatchUtils.excuteBatch(100, addStaffs, a -> this.staffService.saveOnly(a));
    BatchUtils.excuteBatch(100, addUsers, a -> this.userService.saveOnly(a));
    BatchUtils.excuteBatch(100, addUserRoles, a -> addUserRole(a));
    BatchUtils.excuteBatch(100, updateStaffs, ns -> this.staffService.saveOnly(ns));
    BatchUtils.excuteBatch(100, updatePartTimeJobs, ns -> this.partTimeJobService.saveOnly(ns));
    deleteStaffs.stream().peek(d -> d.setBase("1")).collect(Collectors.toList());
    BatchUtils.excuteBatch(100, deleteStaffs, ds -> {
          try {
            this.staffService.save(ds);
          } catch (ServiceException e) {
            e.printStackTrace();
          } 
        });
    List<String> deleteStaffIds = CollectionHelper.extractToList(deleteStaffs, d -> d.getUuid());
    BatchUtils.excuteBatch(100, deleteStaffIds, ds -> this.userService.disableAccountByStaffIds(ds));
    Set<String> uuids = new HashSet<>();
    if (!reholdPartTimeJobs.isEmpty())
      BatchUtils.excuteBatch(100, reholdPartTimeJobs, ds -> {
            try {
              uuids.clear();
              CollectionHelper.extractTo(ds, (), uuids);
              this.partTimeJobService.updateState(tenantId, 0, uuids);
            } catch (Exception e) {
              e.printStackTrace();
            } 
          }); 
    if (!deletePartTimeJobs.isEmpty())
      BatchUtils.excuteBatch(100, deletePartTimeJobs, ds -> {
            try {
              uuids.clear();
              CollectionHelper.extractTo(ds, (), uuids);
              this.partTimeJobService.updateState(tenantId, 1, uuids);
            } catch (Exception e) {
              e.printStackTrace();
            } 
          }); 
    deleteUnmatchStructureAgain(tadmin, notAllowDeleteStructureIdList);
    this.structureService.initOrgOrder(tadmin.getTenant(), null);
    List<StructurePOJO> structurePOJOS = new ArrayList<>();
    for (StructurePOJO structureEntity : addStructures)
      structurePOJOS.add(structureEntity); 
    BatchUtils.excuteBatch(500, structurePOJOS, s -> this.dingtalkService.publishOrgAddOrCancelOrDeleteEvent(s, tenantId, tadmin, "0"));
    BatchUtils.excuteBatch(100, orgInfoChangedPublishList, a -> this.dingtalkService.publishOrgInfoChangedEvent(a, tenantId, tadmin));
    BatchUtils.excuteBatch(100, orgDataChangedPublishList, a -> this.dingtalkService.publishOrgDataChangedEvent(a, tenantId, tadmin));
    List<String> addedStaffIdList = CollectionHelper.extractToList(addStaffs, a -> a.getUuid());
    BatchUtils.excuteBatch(500, addedStaffIdList, a -> this.dingtalkService.publishStaffBaseChangedEvent(a, tenantId, tadmin, "0"));
    BatchUtils.excuteBatch(100, updateStaffPublishList, c -> this.dingtalkService.publishStaffInfoChangedEvent(c, tenantId, tadmin, "0"));
    BatchUtils.excuteBatch(100, updateStaffTypeOnePublishList, c -> this.dingtalkService.publishStaffInfoChangedEvent(c, tenantId, tadmin, "1"));
    BatchUtils.excuteBatch(100, deleteStaffIds, d -> this.dingtalkService.publishStaffBaseChangedEvent(d, tenantId, tadmin, "1"));
    List<PartTimeJob> addchanges = new ArrayList<>();
    for (PartTimeJob partTimeJobEntity : addPartTimeJobs)
      addchanges.add(partTimeJobEntity); 
    BatchUtils.excuteBatch(100, addchanges, c -> this.dingtalkService.publishStaffPartJobAddOrDeleteEvent(c, tenantId, tadmin, "0"));
    BatchUtils.excuteBatch(100, updatePartTimeJobPublishList, c -> this.dingtalkService.publishStaffPartJobChangedEvent(c, tenantId, tadmin));
    if (!deletePartTimeJobs.isEmpty()) {
      List<UpdatePartJobPair> changes = new ArrayList<>();
      for (PartTimeJob partTimeJobEntity : deletePartTimeJobs) {
        PartTimeJob old = (PartTimeJob)EntityUtil.copySimilar(partTimeJobEntity, PartTimeJob.class);
        old.setState(Integer.valueOf(1));
        changes.add(new UpdatePartJobPair(old, partTimeJobEntity));
      } 
      BatchUtils.excuteBatch(100, changes, c -> this.applicationService.publishStaffPartJobChangedEvent(new StaffPartJobChangedEvent(changes, tenantId, ShiroUser.getCurrentUserEntity())));
    } 
    List<RecordDetailEntity> recordDetailList = new ArrayList<>();
    Map<String, StrSuppose> zgtjIdAndOrg = CollectionHelper.mapDict(strSupposes, a -> a.getOrgId());
    for (BasicPOJO basicPOJO : addUnits) {
      StrSuppose zxbcUnitDTO = zgtjIdAndOrg.get(basicPOJO.getOrgNum());
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, basicPOJO.getName(), "1", basicPOJO.getOrgNum(), JSON.toJSONString(zxbcUnitDTO), "0", RecordDetailEntity.OPERATION_ADD, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    for (DeptPOJO deptPOJO : addDepts) {
      StrSuppose zxbcDeptDTO = zgtjIdAndOrg.get(deptPOJO.getOrgNum());
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, deptPOJO.getName(), "2", deptPOJO.getOrgNum(), JSON.toJSONString(zxbcDeptDTO), "0", RecordDetailEntity.OPERATION_ADD, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    for (PosPOJO posPOJO : addPos) {
      StrSuppose zxbcPosDTO = zgtjIdAndOrg.get(posPOJO.getOrgNum());
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, posPOJO.getName(), "3", posPOJO.getOrgNum(), JSON.toJSONString(zxbcPosDTO), "0", RecordDetailEntity.OPERATION_ADD, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    List<StructurePOJO> newUpdateStructureList = CollectionHelper.distinct(updateStructures, (a, b) -> a.getUuid().equals(b.getUuid()));
    for (StructurePOJO newUpdateStructure : newUpdateStructureList) {
      StrSuppose zxbcDTO = new StrSuppose();
      if (StringUtils.isNotBlank(newUpdateStructure.getOrgNum()))
        zxbcDTO = zgtjIdAndOrg.get(newUpdateStructure.getOrgNum()); 
      if (newUpdateStructure.getOrgType().intValue() == 1) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, newUpdateStructure.getOrgName(), "1", newUpdateStructure.getOrgNum(), JSON.toJSONString(zxbcDTO), "0", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
        continue;
      } 
      if (newUpdateStructure.getOrgType().intValue() == 2) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, newUpdateStructure.getOrgName(), "2", newUpdateStructure.getOrgNum(), JSON.toJSONString(zxbcDTO), "0", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
        continue;
      } 
      if (newUpdateStructure.getOrgType().intValue() == 3) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, newUpdateStructure.getName(), "3", newUpdateStructure.getOrgNum(), JSON.toJSONString(zxbcDTO), "0", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
      } 
    } 
    Map<String, StructurePOJO> orgIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgId());
    List<String> finalDeleteStructureIdList = new ArrayList<>();
    finalDeleteStructureIdList.addAll(deleteStructureIdList);
    finalDeleteStructureIdList.addAll(notAllowDeleteStructureIdList);
    for (String s : finalDeleteStructureIdList) {
      StructurePOJO structurePOJO = orgIdAndStructure.get(s);
      if (structurePOJO.getOrgType().intValue() == 1) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, structurePOJO.getName(), "1", null, null, "0", RecordDetailEntity.OPERATION_DELETE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
        continue;
      } 
      if (structurePOJO.getOrgType().intValue() == 2) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, structurePOJO.getName(), "2", null, null, "0", RecordDetailEntity.OPERATION_DELETE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
        continue;
      } 
      if (structurePOJO.getOrgType().intValue() == 3) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, structurePOJO.getName(), "3", null, null, "0", RecordDetailEntity.OPERATION_DELETE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStr.getUuid());
        recordDetailList.add(recordDetailEntity);
      } 
    } 
    Map<String, List<StaffSuppose>> zxbcUserIdAndUsers = CollectionHelper.mapListDict(staffSupposes, a -> a.getWorkNumber());
    for (StaffEntity staff : addStaffs) {
      List<StaffSuppose> zxbcUserDTOS = zxbcUserIdAndUsers.get(staff.getStaffNum());
      StaffSuppose zxbcUserDTO = ((List<StaffSuppose>)zxbcUserDTOS.stream().filter(a -> a.isMainPosition()).collect(Collectors.toList())).get(0);
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, staff.getName(), "4", staff.getStaffNum(), JSON.toJSONString(zxbcUserDTO), "1", RecordDetailEntity.OPERATION_ADD, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    Map<String, StaffEntity> uuidAndStaff = CollectionHelper.mapDict(allStaffs, a -> a.getUuid());
    Map<String, PosPOJO> uuidAndPosPOJO = CollectionHelper.mapDict(allPos, a -> a.getUuid());
    for (PartTimeJob partTimeJob : addPartTimeJobs) {
      StaffEntity staffEntity = uuidAndStaff.get(partTimeJob.getStaffId());
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, partTimeJob.getStaffName(), "5", String.valueOf(staffEntity.getWorkNumber()), JSON.toJSONString(partTimeJob), "1", RecordDetailEntity.OPERATION_ADD, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    updateStaffs.removeAll(deleteStaffList);
    for (StaffEntity staff : updateStaffs) {
      StaffSuppose zxbcUserDTO = new StaffSuppose();
      if (StringUtils.isNotBlank(staff.getStaffNum())) {
        List<StaffSuppose> zxbcUserDTOS = zxbcUserIdAndUsers.get(staff.getStaffNum());
        if (zxbcUserDTOS != null)
          zxbcUserDTO = ((List<StaffSuppose>)zxbcUserDTOS.stream().filter(a -> a.isMainPosition()).collect(Collectors.toList())).get(0); 
      } 
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, staff.getName(), "4", staff.getStaffNum(), JSON.toJSONString(zxbcUserDTO), "1", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    for (PartTimeJob partTimeJob : updatePartTimeJobs) {
      StaffEntity staffEntity = uuidAndStaff.get(partTimeJob.getStaffId());
      if (staffEntity == null)
        continue; 
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, partTimeJob.getStaffName(), "5", (staffEntity != null) ? String.valueOf(staffEntity.getWorkNumber()) : staffEntity.getStaffNum(), (staffEntity != null) ? JSON.toJSONString(staffEntity) : "", "1", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, "迁移导致兼职更新(云中创建的兼职id：" + partTimeJob.getUuid() + ")", recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    for (StaffEntity staff : deleteStaffs) {
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, staff.getName(), "4", staff.getStaffNum(), null, "1", RecordDetailEntity.OPERATION_DELETE, RecordDetailEntity.FLAG_SUCCESS, null, recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    if (!reholdPartTimeJobs.isEmpty())
      for (PartTimeJob partTimeJob : reholdPartTimeJobs) {
        RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, partTimeJob.getStaffName(), "5", partTimeJob.getStaffId(), null, "1", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, "恢复兼职", recordDataStaff.getUuid());
        recordDetailList.add(recordDetailEntity);
      }  
    for (PartTimeJob partTimeJob : deletePartTimeJobs) {
      RecordDetailEntity recordDetailEntity = new RecordDetailEntity(tenantId, nowDate, partTimeJob.getStaffName(), "5", partTimeJob.getStaffId(), JSON.toJSONString(partTimeJob), "1", RecordDetailEntity.OPERATION_UPDATE, RecordDetailEntity.FLAG_SUCCESS, "免除兼职", recordDataStaff.getUuid());
      recordDetailList.add(recordDetailEntity);
    } 
    this.recordDetailService.save(recordDetailList);
  }
  
  public void addBasic(List<BasicPOJO> basics) {
    String excuteSql = splitBasicSql(basics);
    this.basicService.batchAdd(excuteSql);
  }
  
  private String splitBasicSql(List<BasicPOJO> basics) {
    StringBuilder excuteSql = Strings.build(new String[] { "insert into org_basic ( uuid, status, create_ts, creator, code,end_date, name, show_order, start_date, tenant_id,parent_id, delete_flag ,org_num) VALUES" });
    Integer index = Integer.valueOf(0);
    for (BasicPOJO basic : basics) {
      excuteSql.append("('").append(basic.getUuid()).append("',");
      excuteSql.append(basic.getStatus()).append(",");
      excuteSql.append("'").append(DateFormatUtils.format(basic.getCreateTs(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(basic.getCreator()).append("',");
      excuteSql.append("'").append(basic.getCode()).append("',");
      excuteSql.append("'").append(DateFormatUtils.format(basic.getEndDate(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(basic.getName()).append("',");
      excuteSql.append(basic.getShowOrder()).append(",");
      excuteSql.append("'").append(DateFormatUtils.format(basic.getStartDate(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(basic.getTenantId()).append("',");
      excuteSql.append("'").append(basic.getParentId()).append("',");
      excuteSql.append(basic.getDeleteFlag().booleanValue() ? 1 : 0).append(",'");
      excuteSql.append(basic.getOrgNum()).append("')");
      if (!index.equals(Integer.valueOf(basics.size() - 1)))
        excuteSql.append(","); 
      Integer integer1 = index, integer2 = index = Integer.valueOf(index.intValue() + 1);
    } 
    return excuteSql.toString();
  }
  
  private String splitDeptSql(List<DeptPOJO> depts) {
    StringBuilder excuteSql = Strings.build(new String[] { "insert into org_dept ( uuid, status, create_ts, creator, code,end_date, name,parent_dept, show_order, start_date, unit_id, tenant_id, delete_flag, qywx_id ) VALUES" });
    Integer index = Integer.valueOf(0);
    for (DeptPOJO dept : depts) {
      excuteSql.append("('").append(dept.getUuid()).append("',");
      excuteSql.append(dept.getStatus()).append(",");
      excuteSql.append("'").append(DateFormatUtils.format(dept.getCreateTs(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(dept.getCreator()).append("',");
      excuteSql.append("'").append(dept.getCode()).append("',");
      excuteSql.append("'").append(DateFormatUtils.format(dept.getEndDate(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(dept.getName()).append("',");
      if (StringUtils.isBlank(dept.getParentDept())) {
        excuteSql.append("null").append(",");
      } else {
        excuteSql.append("'").append(dept.getParentDept()).append("',");
      } 
      excuteSql.append(dept.getShowOrder()).append(",");
      excuteSql.append("'").append(DateFormatUtils.format(dept.getStartDate(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(dept.getUnitId()).append("',");
      excuteSql.append("'").append(dept.getTenantId()).append("',");
      excuteSql.append(dept.getDeleteFlag().booleanValue() ? 1 : 0).append(",");
      excuteSql.append(dept.getQywxId()).append(")");
      if (!index.equals(Integer.valueOf(depts.size() - 1)))
        excuteSql.append(","); 
      Integer integer1 = index, integer2 = index = Integer.valueOf(index.intValue() + 1);
    } 
    return excuteSql.toString();
  }
  
  public void addPos(List<PosPOJO> posList) {
    String excuteSql = this.dingtalkService.splitPosSql(posList);
    this.posService.batchAdd(excuteSql);
  }
  
  public void adddept(List<DeptPOJO> depts) {
    String excuteSql = splitDeptSql(depts);
    this.deptService.batchAdd(excuteSql);
  }
  
  public void addStruncture(List<StructurePOJO> structures) {
    String excuteSql = splitStructureSql(structures);
    this.structureService.batchAdd(excuteSql);
  }
  
  private String splitStructureSql(List<StructurePOJO> Structures) {
    StringBuilder excuteSql = Strings.build(new String[] { "insert into org_structure ( uuid, status, create_ts, creator, children_id, org_code, org_id,org_name, org_type, show_order, tenant_id, parent_id, end_date, start_date, delete_flag, report_flag, org_num ) VALUES" });
    Integer index = Integer.valueOf(0);
    for (StructurePOJO structure : Structures) {
      excuteSql.append("('").append(structure.getUuid()).append("',");
      excuteSql.append(structure.getStatus()).append(",");
      excuteSql.append("'").append(DateFormatUtils.format(structure.getCreateTs(), "yyyy-MM-dd HH:mm:ss")).append("',");
      excuteSql.append("'").append(structure.getCreator()).append("',");
      if (structure.getChildrenId() == null) {
        excuteSql.append("null").append(",");
      } else {
        excuteSql.append("'").append(structure.getChildrenId()).append("',");
      } 
      excuteSql.append("'").append(structure.getOrgCode()).append("',");
      excuteSql.append("'").append(structure.getOrgId()).append("',");
      excuteSql.append("'").append(structure.getOrgName()).append("',");
      excuteSql.append(structure.getOrgType()).append(",");
      excuteSql.append(structure.getShowOrder()).append(",");
      excuteSql.append("'").append(structure.getTenantId()).append("',");
      if (structure.getParentId() == null || structure.getParentId().isEmpty()) {
        excuteSql.append("null").append(",");
      } else {
        excuteSql.append("'").append(structure.getParentId()).append("',");
      } 
      excuteSql.append("'").append(DateFormatUtils.format(structure.getEndDate(), "yyyy-MM-dd HH:mm")).append("',");
      excuteSql.append("'").append(DateFormatUtils.format(structure.getStartDate(), "yyyy-MM-dd HH:mm")).append("',");
      excuteSql.append(structure.getDeleteFlag().booleanValue() ? 1 : 0).append(",");
      excuteSql.append(structure.getReportFlag().booleanValue() ? 1 : 0).append(",'");
      excuteSql.append(structure.getOrgNum()).append("')");
      if (!index.equals(Integer.valueOf(Structures.size() - 1)))
        excuteSql.append(","); 
      Integer integer1 = index, integer2 = index = Integer.valueOf(index.intValue() + 1);
    } 
    return excuteSql.toString();
  }
  
  public void deleteUnmatchStructureAgain(UserEntity tadmin, List<String> notAllowDeleteStructureIdList) {
    if (notAllowDeleteStructureIdList.size() > 100) {
      List<List<String>> lists = CollectionHelper.splitList(notAllowDeleteStructureIdList, 100);
      for (List<String> list : lists) {
        List<String> tempList = this.structureService.judgeDeleteStructure(list.<String>toArray(new String[list.size()]), "1", tadmin.getTenantId());
        notAllowDeleteStructureIdList.removeAll(tempList);
      } 
    } else {
      List<String> list = this.structureService.judgeDeleteStructure(notAllowDeleteStructureIdList.<String>toArray(new String[notAllowDeleteStructureIdList.size()]), "1", tadmin.getTenantId());
      notAllowDeleteStructureIdList.removeAll(list);
    } 
    if (notAllowDeleteStructureIdList != null && notAllowDeleteStructureIdList.size() > 0)
      BatchUtils.excuteBatch(100, notAllowDeleteStructureIdList, dt -> this.structureService.deleteOrg(dt, tadmin.getTenant(), tadmin)); 
  }
  
  public void judgeDeleteStaff(List<String> deleteStaffIdList, String tenantId) {
    if (deleteStaffIdList.size() > 1) {
      List<List<String>> lists = CollectionHelper.splitList(deleteStaffIdList, 1);
      for (List<String> list : lists) {
        List<String> tempList = this.staffService.judgeDeleteStaff(list, tenantId);
        deleteStaffIdList.removeAll(tempList);
      } 
    } else {
      List<String> list = this.staffService.judgeDeleteStaff(deleteStaffIdList, tenantId);
      deleteStaffIdList.removeAll(list);
    } 
  }
  
  public void addUserRole(List<UserRoleEntity> userRoleList) {
    String excuteSql = this.dingtalkService.splitUserRoleSql(userRoleList);
    try {
      this.userRoleService.batchAdd(excuteSql);
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println(excuteSql);
    } 
  }
  
  public void judgeDeleteStr(List<String> deleteStructureIdList, List<String> notAllowDeleteStructureIdList, String tenantId) {
    if (deleteStructureIdList.size() > 100) {
      List<List<String>> lists = CollectionHelper.splitList(deleteStructureIdList, 100);
      for (List<String> list : lists) {
        List<String> tempList = this.structureService.judgeDeleteStructure(list.<String>toArray(new String[list.size()]), "1", tenantId);
        deleteStructureIdList.removeAll(tempList);
        notAllowDeleteStructureIdList.addAll(tempList);
      } 
    } else {
      List<String> list = this.structureService.judgeDeleteStructure(deleteStructureIdList.<String>toArray(new String[deleteStructureIdList.size()]), "1", tenantId);
      deleteStructureIdList.removeAll(list);
      notAllowDeleteStructureIdList.addAll(list);
    } 
  }
  
  public void autoSyncDeleteStaff(List<StaffEntity> allStaffs, List<StaffSuppose> allZxbcUsers, List<StaffEntity> deleteStaffs, Map<String, RecyclePOJO> recyclePOJOMap) {
    Map<String, StaffEntity> workNumberMap = CollectionHelper.mapDict(allStaffs, a -> a.getWorkNumber());
    Map<String, StaffEntity> staffNumMap = CollectionHelper.mapDict(allStaffs, a -> a.getStaffNum());
    ArrayList<StaffEntity> deleteStaffList = new ArrayList<>();
    for (StaffSuppose staff : allZxbcUsers) {
      if (staff.isMainPosition() && 
        !StringUtils.equals("1", staff.getServicestatus())) {
        StaffEntity staffEntity = workNumberMap.get(staff.getWorkNumber());
        if (staffEntity == null)
          staffEntity = staffNumMap.get(staff.getWorkNumber()); 
        if (staffEntity == null || 
          !StringUtils.equals(staffEntity.getBase(), "0"))
          continue; 
        deleteStaffList.add(staffEntity);
      } 
    } 
    deleteStaffs.addAll(deleteStaffList);
  }
  
  public void autoSyncUpdateStaff(List<UserEntity> addUsers, List<UserRoleEntity> addUserRoles, Map<String, RecyclePOJO> recyclePOJOMap, UserEntity tadmin, List<StructurePOJO> allHjStructures, List<BasicPOJO> allUnits, List<DeptPOJO> allDepts, List<PosPOJO> allPos, List<StaffEntity> allStaffs, List<PartTimeJob> allPartTimeJobs, List<StaffSuppose> allZxbcUsers, List<StaffEntity> updateStaffs, List<PartTimeJob> addPartTimeJobs, List<PartTimeJob> reHoldPartTimeJobs, List<PartTimeJob> deletePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePair> updateStaffTypeOnePublishList) {
    Map<String, StructurePOJO> zgtjIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    Map<String, StructurePOJO> orgIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgId());
    Map<String, BasicPOJO> uuidAnUnit = CollectionHelper.mapDict(allUnits, a -> a.getUuid());
    Map<String, DeptPOJO> uuidAndDept = CollectionHelper.mapDict(allDepts, a -> a.getUuid());
    Map<String, PosPOJO> uuidAndPos = CollectionHelper.mapDict(allPos, a -> a.getUuid());
    Map<String, StaffEntity> zxbcIdAndHJStaff = CollectionHelper.mapDict(allStaffs, a -> a.getStaffNum());
    Map<String, StaffEntity> weWorkNumberIdAndHJStaff = CollectionHelper.mapDict(allStaffs, a -> a.getWorkNumber());
    Map<String, List<PartTimeJob>> staffIdAndPartTimeJobs = CollectionHelper.mapListDict(allPartTimeJobs, a -> a.getStaffId());
    Map<String, List<StaffSuppose>> zxbcIdAndUsers = CollectionHelper.mapListDict(allZxbcUsers, a -> a.getWorkNumber());
    List<UserEntity> userEntities = this.userService.findByTenantId(tadmin.getTenantId());
    Map<String, UserEntity> userEntityMap = CollectionHelper.mapDict(userEntities, user -> user.getStaff().getUuid());
    ArrayList<StaffEntity> updateStaffList = new ArrayList<>();
    ArrayList<PartTimeJob> addPartTimeJobList = new ArrayList<>();
    ArrayList<PartTimeJob> deletePartTimeJobList = new ArrayList<>();
    List<String> deleteRecycleObids = new ArrayList<>();
    List<String> enableUsers = new ArrayList<>();
    String loginUserUcode = tadmin.getUcode();
    RoleEntity roleEntity = (RoleEntity)EntityUtil.copySimilar(this.roleService.findByRoleCode("t_staff"), RoleEntity.class);
    for (StaffSuppose zxbcUser : allZxbcUsers) {
      if (!zxbcUser.isMainPosition())
        continue; 
      StaffEntity staff = zxbcIdAndHJStaff.get(String.valueOf(zxbcUser.getWorkNumber()));
      if (staff == null)
        staff = weWorkNumberIdAndHJStaff.get(String.valueOf(zxbcUser.getWorkNumber())); 
      if (staff != null) {
        if (staff.getWorkNumber().equals("CHN0011341"))
          System.out.println(); 
        boolean match = true;
        if (!StringUtils.equals(staff.getStaffNum(), zxbcUser.getWorkNumber())) {
          match = false;
          staff.setStaffNum(zxbcUser.getWorkNumber());
        } 
        if (!StringUtils.equals(staff.getEmail(), zxbcUser.getEmail())) {
          match = false;
          staff.setEmail(zxbcUser.getEmail());
        } 
        if (staff.getGender() == null)
          staff.setGender(Short.valueOf((short)1)); 
        if (staff.getGender().shortValue() != (short)(StringUtils.equals("M", zxbcUser.getGender()) ? 1 : 2)) {
          staff.setGender(Short.valueOf((short)("M".equals(zxbcUser.getGender()) ? 1 : 2)));
          match = false;
        } 
        StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(staff, StaffEntity.class);
        if (!StringUtils.equals(staff.getBase(), "0") && 
          StringUtils.equals("1", zxbcUser.getServicestatus())) {
          match = false;
          staff.setBase("0");
          UserEntity user = userEntityMap.get(staff.getUuid());
          if (user != null) {
            enableUsers.add(staff.getUuid());
          } else {
            if (recyclePOJOMap.get(staff.getUuid()) != null)
              deleteRecycleObids.add(staff.getUuid()); 
            String loginName = "ZXBC" + staff.getStaffNum();
            String ucode = loginUserUcode + Randomizer.getRandomString(3);
            UserEntity addedUser = this.dingtalkService.packUser(staff, loginName, tadmin.getTenant(), ucode, tadmin);
            staff.setIsUser(Integer.valueOf(1));
            this.dingtalkService.entryptPassword(addedUser);
            UserRoleEntity userRoleEntity = this.dingtalkService.packUserRole(addedUser, roleEntity, null);
            addUsers.add(addedUser);
            addUserRoles.add(userRoleEntity);
          } 
        } 
        if (!staff.getStaffName().equals(zxbcUser.getStaffName())) {
          staff.setStaffName(zxbcUser.getStaffName());
          updateStaffPublishList.add(new UpdatePair(oldStaffEntity, staff));
          match = false;
        } 
        StructurePOJO structurePos = zgtjIdAndStructure.get("p" + String.valueOf(zxbcUser.getPosId()));
        if (structurePos == null)
          continue; 
        if (!structurePos.getOrgId().equals(staff.getPosId())) {
          staff.setPosId(structurePos.getOrgId());
          staff.setPosCode(structurePos.getOrgCode());
          staff.setPosName(structurePos.getName());
          PosPOJO posPOJO = uuidAndPos.get(structurePos.getOrgId());
          if (StringUtils.isNotBlank(posPOJO.getDeptId())) {
            DeptPOJO deptEntity = uuidAndDept.get(posPOJO.getDeptId());
            staff.setDeptId(deptEntity.getUuid());
            staff.setDeptCode(deptEntity.getCode());
            staff.setDeptName(deptEntity.getName());
          } 
          BasicPOJO basicEntity = uuidAnUnit.get(posPOJO.getUnitId());
          staff.setUnitId(basicEntity.getUuid());
          staff.setUnitCode(basicEntity.getCode());
          staff.setUnitName(basicEntity.getName());
          updateStaffTypeOnePublishList.add(new UpdatePair(oldStaffEntity, staff));
          match = false;
        } 
        if (!match)
          updateStaffList.add(staff); 
        List<PartTimeJob> partTimeJobs = (staffIdAndPartTimeJobs.get(staff.getUuid()) != null) ? staffIdAndPartTimeJobs.get(staff.getUuid()) : new ArrayList<>();
        List<StaffSuppose> zgtjUserDTOS = zxbcIdAndUsers.get(zxbcUser.getWorkNumber());
        List<StaffSuppose> zgtjPartTimeJobs = (CollectionHelper.filter(CollectionHelper.filter(zgtjUserDTOS, a -> !a.isMainPosition()), b -> ("0".equals(b.getCurrentposition()) && "1".equals(b.getDefaultposition()))) != null) ? CollectionHelper.filter(zgtjUserDTOS, a -> !a.isMainPosition()) : new ArrayList<>();
        List<String> zgtjPartTimeJobIds = CollectionHelper.extractToList(zgtjPartTimeJobs, z -> "p" + z.getPosId());
        ArrayList<String> tempList = new ArrayList<>();
        for (PartTimeJob partTimeJob : partTimeJobs) {
          StructurePOJO posPOJO = orgIdAndStructure.get(partTimeJob.getPosId());
          boolean isUnhold = partTimeJob.stateOfUnhold();
          if (StringUtils.isBlank(posPOJO.getOrgNum())) {
            if (!isUnhold)
              deletePartTimeJobList.add(partTimeJob); 
            continue;
          } 
          if (zgtjPartTimeJobIds.contains(String.valueOf(posPOJO.getOrgNum()))) {
            tempList.add(String.valueOf(posPOJO.getOrgNum()));
            if (isUnhold)
              reHoldPartTimeJobs.add(partTimeJob); 
            continue;
          } 
          if (!isUnhold)
            deletePartTimeJobList.add(partTimeJob); 
        } 
        for (StaffSuppose zgtjPartTimeJob : zgtjPartTimeJobs) {
          if (tempList.contains("p" + zgtjPartTimeJob.getPosId()) || 
            !"0".equals(zgtjPartTimeJob.getCurrentposition()) || !"1".equals(zgtjPartTimeJob.getDefaultposition()))
            continue; 
          PartTimeJob partTimeJob = new PartTimeJob();
          partTimeJob.setUuid(Identities.uuid2());
          partTimeJob.setCreator(tadmin.getUuid());
          partTimeJob.setTenantId(tadmin.getTenantId());
          StructurePOJO pos = zgtjIdAndStructure.get(String.valueOf("p" + zgtjPartTimeJob.getPosId()));
          if (pos == null)
            continue; 
          partTimeJob.setPosId(pos.getOrgId());
          partTimeJob.setPosName(pos.getOrgName());
          partTimeJob.setPosCode(pos.getOrgCode());
          PosPOJO posPOJO = uuidAndPos.get(pos.getOrgId());
          if (StringUtils.isNotBlank(posPOJO.getDeptId())) {
            DeptPOJO deptEntity = uuidAndDept.get(posPOJO.getDeptId());
            if (deptEntity != null) {
              partTimeJob.setDeptId(deptEntity.getUuid());
              partTimeJob.setDeptName(deptEntity.getName());
              partTimeJob.setDeptCode(deptEntity.getCode());
            } 
          } 
          BasicPOJO basicEntity = uuidAnUnit.get(posPOJO.getUnitId());
          partTimeJob.setUnitId(basicEntity.getUuid());
          partTimeJob.setUnitName(basicEntity.getName());
          partTimeJob.setUnitCode(basicEntity.getCode());
          partTimeJob.setStaffId(staff.getUuid());
          partTimeJob.setStaffName(staff.getStaffName());
          partTimeJob.setStaffOrder(staff.getShowOrder());
          partTimeJob.setState(Integer.valueOf(0));
          partTimeJob.setShowOrder(Double.valueOf(0.0D));
          addPartTimeJobList.add(partTimeJob);
        } 
      } 
    } 
    if (deleteRecycleObids.size() > 0)
      this.recycleService.deleteByObjectId(deleteRecycleObids); 
    if (enableUsers.size() > 0)
      BatchUtils.excuteBatch(100, enableUsers, ds -> this.userService.enableAccountByStaffIds(ds)); 
    updateStaffs.addAll(updateStaffList);
    addPartTimeJobs.addAll(addPartTimeJobList);
    deletePartTimeJobs.addAll(deletePartTimeJobList);
  }
  
  public void autoSyncDeleteStr(List<StructurePOJO> allHjStructures, List<StrSuppose> allZxbcDepts, List<StructurePOJO> unMatchStructures) {
    List<String> hjZxbcIds = CollectionHelper.extractToList(CollectionHelper.filter(allHjStructures, a -> StringUtils.isNotBlank(a.getOrgNum())), a -> a.getOrgNum());
    Map<String, StructurePOJO> zxbcIdAndStructureMap = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    Map<String, StrSuppose> zxbcIdAndWXDeptDTO = CollectionHelper.mapDict(allZxbcDepts, a -> a.getOrgId());
    for (String zxbcId : hjZxbcIds) {
      StrSuppose orgMatchEntity = zxbcIdAndWXDeptDTO.get(zxbcId);
      if (orgMatchEntity != null && 
        orgMatchEntity.getDeleteFlag().equals("0")) {
        StructurePOJO deleteStructurePOJO = zxbcIdAndStructureMap.get(zxbcId);
        if (deleteStructurePOJO == null || 
          deleteStructurePOJO.getDeleteFlag().booleanValue())
          continue; 
        unMatchStructures.add(deleteStructurePOJO);
      } 
    } 
  }
  
  public void autoSyncAddStaff(UserEntity tadmin, List<StructurePOJO> allHjStructures, List<BasicPOJO> allUnits, List<DeptPOJO> allDepts, List<StaffEntity> allStaffs, List<PartTimeJob> allPartTimeJobs, List<StaffSuppose> allZxbcUsers, List<StaffEntity> addStaffs, List<PartTimeJob> addPartTimeJobs, List<UserEntity> addUsers, List<UserRoleEntity> addUserRoles) {
    Map<String, StructurePOJO> uuidAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getUuid());
    Map<String, StructurePOJO> orgIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgId());
    Map<String, StructurePOJO> zxbcIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    Map<String, BasicPOJO> uuidAnUnit = CollectionHelper.mapDict(allUnits, a -> a.getUuid());
    Map<String, DeptPOJO> uuidAndDept = CollectionHelper.mapDict(allDepts, a -> a.getUuid());
    Map<String, StaffEntity> zxbcIdAndStaffMap = CollectionHelper.mapDict(allStaffs, a -> a.getStaffNum());
    Map<String, StaffEntity> workNumberIdAndStaffMap = CollectionHelper.mapDict(allStaffs, a -> a.getWorkNumber());
    Map<String, List<StaffSuppose>> allZgtjIdAndUsers = CollectionHelper.mapListDict(allZxbcUsers, a -> a.getWorkNumber());
    List<StaffEntity> addedStaffList = new ArrayList<>();
    List<PartTimeJob> addedPartTimeJobList = new ArrayList<>();
    List<UserEntity> addedUserList = new ArrayList<>();
    List<UserRoleEntity> addedUserRoleList = new ArrayList<>();
    Double maxShowOrder = this.staffService.getStaffMaxOrder(tadmin.getTenantId());
    TenantEntity tenant = tadmin.getTenant();
    RoleEntity roleEntity = (RoleEntity)EntityUtil.copySimilar(this.roleService.findByRoleCode("t_staff"), RoleEntity.class);
    String loginUserUcode = tadmin.getUcode();
    int i = (int)(Math.random() * 900.0D + 100.0D);
    for (StaffSuppose zgtjUserDTO : allZxbcUsers) {
      if (!zgtjUserDTO.isMainPosition())
        continue; 
      if (zgtjUserDTO.getWorkNumber().equals("CHN0006316"))
        System.out.println(); 
      if (zgtjUserDTO.getWorkNumber().equals("CHN0013879"))
        System.out.println(); 
      if (zgtjUserDTO.getWorkNumber().equals("CHN0027824"))
        System.out.println(); 
      StaffEntity staffEntity = zxbcIdAndStaffMap.get(String.valueOf(zgtjUserDTO.getWorkNumber()));
      if (staffEntity == null)
        staffEntity = workNumberIdAndStaffMap.get(zgtjUserDTO.getWorkNumber()); 
      if (staffEntity == null) {
        List<StaffSuppose> zgtjUsers = allZgtjIdAndUsers.get(zgtjUserDTO.getWorkNumber());
        StaffEntity tempStaffEntity = null;
        for (StaffSuppose zxbcUser : zgtjUsers) {
          if (zxbcUser.isMainPosition()) {
            StructurePOJO structurePos = zxbcIdAndStructure.get("p" + zxbcUser.getPosId());
            if (structurePos == null)
              continue; 
            StructurePOJO structureDept = uuidAndStructure.get(structurePos.getParentId());
            DeptPOJO deptEntity = uuidAndDept.get(structureDept.getOrgId());
            BasicPOJO basicEntity = null;
            if (structureDept.getOrgType().intValue() == 1)
              deptEntity = null; 
            if (deptEntity == null) {
              basicEntity = uuidAnUnit.get(structureDept.getOrgId());
              structureDept = new StructurePOJO();
            } else {
              basicEntity = uuidAnUnit.get(deptEntity.getUnitId());
            } 
            if (basicEntity == null) {
              this.logger.error("not find basentiy{}", zxbcUser);
              continue;
            } 
            StructurePOJO structureBasic = orgIdAndStructure.get(basicEntity.getUuid());
            Double double_1 = maxShowOrder, double_2 = maxShowOrder = Double.valueOf(maxShowOrder.doubleValue() + 1.0D);
            tempStaffEntity = packStaff(zxbcUser, tadmin, structureBasic, structureDept, structurePos, maxShowOrder.doubleValue(), null);
            String loginName = "ZXBC" + tempStaffEntity.getStaffNum();
            String ucode = loginUserUcode + Randomizer.getRandomString(3);
            UserEntity addedUser = this.dingtalkService.packUser(tempStaffEntity, loginName, tenant, ucode, tadmin);
            tempStaffEntity.setIsUser(Integer.valueOf(1));
            this.dingtalkService.entryptPassword(addedUser);
            UserRoleEntity userRoleEntity = this.dingtalkService.packUserRole(addedUser, roleEntity, null);
            addedStaffList.add(tempStaffEntity);
            addedUserList.add(addedUser);
            addedUserRoleList.add(userRoleEntity);
            break;
          } 
        } 
        for (StaffSuppose zxbcUser : zgtjUsers) {
          if (tempStaffEntity == null)
            break; 
          if (zxbcUser.isMainPosition())
            continue; 
          if (!"0".equals(zxbcUser.getCurrentposition()) || !"1".equals(zxbcUser.getDefaultposition()))
            continue; 
          StructurePOJO structurePos = zxbcIdAndStructure.get("p" + String.valueOf(zxbcUser.getPosId()));
          StructurePOJO structureDept = null;
          if (structurePos == null)
            continue; 
          structureDept = uuidAndStructure.get(structurePos.getParentId());
          DeptPOJO deptEntity = null;
          if (structureDept == null) {
            deptEntity = null;
          } else {
            deptEntity = uuidAndDept.get(structureDept.getOrgId());
          } 
          BasicPOJO basicEntity = null;
          StructurePOJO structureBasic = null;
          if (deptEntity == null) {
            structureBasic = orgIdAndStructure.get(zxbcUser.getUnitId());
          } else {
            basicEntity = uuidAnUnit.get(deptEntity.getUnitId());
            if (basicEntity == null)
              continue; 
            structureBasic = orgIdAndStructure.get(basicEntity.getUuid());
          } 
          if (structureBasic == null)
            continue; 
          PartTimeJob addedPartTimeJob = packStaffPartTimeJob(tempStaffEntity, tadmin, structureBasic, structureDept, structurePos, 0, null);
          addedPartTimeJobList.add(addedPartTimeJob);
        } 
      } 
    } 
    allStaffs.addAll(addedStaffList);
    allPartTimeJobs.addAll(addedPartTimeJobList);
    addStaffs.addAll(addedStaffList);
    addPartTimeJobs.addAll(addedPartTimeJobList);
    addUsers.addAll(addedUserList);
    addUserRoles.addAll(addedUserRoleList);
  }
  
  private PartTimeJob packStaffPartTimeJob(StaffEntity staff, UserEntity loginUser, StructurePOJO structureBasic, StructurePOJO structureDept, StructurePOJO structurePos, int partTimeJobShowOrder, Date nowDate) {
    PartTimeJob partTimeJob = new PartTimeJob();
    partTimeJob.setUuid(Identities.uuid2());
    partTimeJob.setStatus("1");
    partTimeJob.setCreateTs(nowDate);
    partTimeJob.setCreator(loginUser.getUuid());
    partTimeJob.setTenantId(loginUser.getTenantId());
    partTimeJob.setUnitId(structureBasic.getOrgId());
    partTimeJob.setUnitName(structureBasic.getOrgName());
    partTimeJob.setUnitCode(structureBasic.getOrgCode());
    partTimeJob.setDeptId(structureDept.getOrgId());
    partTimeJob.setDeptName(structureDept.getOrgName());
    partTimeJob.setDeptCode(structureDept.getOrgCode());
    partTimeJob.setPosId(structurePos.getOrgId());
    partTimeJob.setPosName(structurePos.getOrgName());
    partTimeJob.setPosCode(structurePos.getOrgCode());
    partTimeJob.setStaffId(staff.getUuid());
    partTimeJob.setStaffName(staff.getStaffName());
    partTimeJob.setStaffOrder(staff.getShowOrder());
    partTimeJob.setStartDate(nowDate);
    partTimeJob.setState(Integer.valueOf(0));
    partTimeJob.setShowOrder(Double.valueOf(partTimeJobShowOrder));
    return partTimeJob;
  }
  
  private StaffEntity packStaff(StaffSuppose zxbcUserDTO, UserEntity loginUser, StructurePOJO structureBasic, StructurePOJO structureDept, StructurePOJO structurePos, double showOrder, Date nowDate) {
    StaffEntity staff = new StaffEntity();
    staff.setUuid(Identities.uuid2());
    staff.setStatus(Integer.valueOf(1));
    staff.setCreateTs(nowDate);
    staff.setCreator(loginUser.getUuid());
    staff.setTenantId(loginUser.getTenantId());
    staff.setStaffName(zxbcUserDTO.getStaffName());
    staff.setWorkNumber(zxbcUserDTO.getWorkNumber());
    staff.setShowOrder(Double.valueOf(showOrder));
    staff.setEmail(zxbcUserDTO.getEmail());
    staff.setUnitId(structureBasic.getOrgId());
    staff.setUnitName(structureBasic.getOrgName());
    staff.setUnitCode(structureBasic.getOrgCode());
    staff.setDeptId(structureDept.getOrgId());
    staff.setDeptName(structureDept.getOrgName());
    staff.setDeptCode(structureDept.getOrgCode());
    staff.setPosId(structurePos.getOrgId());
    staff.setPosName(structurePos.getOrgName());
    staff.setPosCode(structurePos.getOrgCode());
    staff.setBase("0");
    staff.setGender(Short.valueOf((short)("M".equals(zxbcUserDTO.getGender()) ? 1 : 2)));
    staff.setStaffNum(String.valueOf(zxbcUserDTO.getWorkNumber()));
    String pinYin = CharacterToSpell.getPinYin(zxbcUserDTO.getStaffName().trim());
    staff.setPhoneticize(pinYin);
    String nameSpelling = this.commonService.getInitialsByName(zxbcUserDTO.getStaffName());
    staff.setNameSpelling(nameSpelling);
    return staff;
  }
  
  public void autoSyncTransferStr(List<StructurePOJO> allHjStructures, List<BasicPOJO> allUnits, List<DeptPOJO> allDepts, List<PosPOJO> allPoses, List<StaffEntity> allStaffs, List<PartTimeJob> allPartTimeJobs, List<StrSuppose> allzxbcOrgs, List<StructurePOJO> updateStructures, List<StructurePOJO> updateStructureList, List<BasicPOJO> updateUnits, List<DeptPOJO> updateDepts, List<PosPOJO> updatePos, List<StaffEntity> updateStaffs, List<PartTimeJob> updatePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePartJobPair> updatePartTimeJobPublishList, List<UpdateOrgDataPair> orgDataChangedPublishList) throws IOException, InterruptedException {
    List<String> zxbcAllIds = CollectionHelper.extractToList(allzxbcOrgs, a -> a.getOrgId());
    Map<String, StrSuppose> zxbcIdAndZgtjOrgMap = CollectionHelper.mapDict(allzxbcOrgs, a -> a.getOrgId());
    Map<String, List<StructurePOJO>> parentIdAndStructures = CollectionHelper.mapListDict(allHjStructures, a -> a.getParentId());
    Map<String, StructurePOJO> zgtjIdAndStructureMap = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    Map<String, StructurePOJO> uuidStructureMap = CollectionHelper.mapDict(allHjStructures, a -> a.getUuid());
    List<StructurePOJO> allHjStructuresCopy = EntityUtil.copySimilar(allHjStructures, StructurePOJO.class);
    ArrayList<StructurePOJO> dragOldParents = new ArrayList<>();
    Map<String, String> tempParentIdAndSonMaxOrgCodeMap = new HashMap<>();
    for (String zxbcId : zxbcAllIds) {
      StructurePOJO dragEntity = zgtjIdAndStructureMap.get(String.valueOf(zxbcId));
      if (dragEntity == null || 
        dragEntity.getOrgCode().equals("100"))
        continue; 
      StructurePOJO dragOldParentEntity = uuidStructureMap.get(dragEntity.getParentId());
      StrSuppose orgMatchEntity = zxbcIdAndZgtjOrgMap.get(zxbcId);
      if (StringUtils.isBlank(dragOldParentEntity.getOrgNum()) || !String.valueOf(dragOldParentEntity.getOrgNum()).equals(orgMatchEntity.getParentid())) {
        dragOldParents.add(dragOldParentEntity);
        StructurePOJO dragNewParentEntity = zgtjIdAndStructureMap.get(String.valueOf(orgMatchEntity.getParentid()));
        String newCode = null;
        newCode = OrgUtils.getAutoCode(allHjStructuresCopy, dragNewParentEntity.getOrgId(), dragNewParentEntity);
        allHjStructuresCopy.add(dragEntity);
        if (dragEntity.getOrgType().intValue() == 1) {
          transferUnit(dragEntity, dragNewParentEntity, newCode, allHjStructures, allUnits, allDepts, allPoses, allStaffs, allPartTimeJobs, updateStructures, updateStructureList, updateUnits, updateDepts, updatePos, updateStaffs, updatePartTimeJobs, updateStaffPublishList, updatePartTimeJobPublishList, orgDataChangedPublishList);
          continue;
        } 
        if (dragEntity.getOrgType().intValue() == 2) {
          transferDept(dragEntity, dragNewParentEntity, newCode, allHjStructures, allDepts, allPoses, allStaffs, allPartTimeJobs, updateStructures, updateStructureList, updateDepts, updatePos, updateStaffs, updatePartTimeJobs, updateStaffPublishList, updatePartTimeJobPublishList, orgDataChangedPublishList);
          continue;
        } 
        if (dragEntity.getOrgType().intValue() == 3)
          transferPos(dragEntity, dragNewParentEntity, newCode, allHjStructures, allDepts, allPoses, allStaffs, allPartTimeJobs, updateStructures, updateStructureList, updatePos, updateStaffs, updatePartTimeJobs, updateStaffPublishList, updatePartTimeJobPublishList, orgDataChangedPublishList); 
      } 
    } 
    if (dragOldParents.size() > 0) {
      Map<String, List<StructurePOJO>> parentIdAndStrs = CollectionHelper.mapListDict(allHjStructures, a -> a.getParentId());
      for (StructurePOJO dragOldParent : dragOldParents) {
        List<StructurePOJO> structurePOJOS = parentIdAndStrs.get(dragOldParent.getUuid());
        if (structurePOJOS == null) {
          dragOldParent.setChildrenId(null);
        } else {
          dragOldParent.setChildrenId(((StructurePOJO)structurePOJOS.get(0)).getUuid());
        } 
        updateStructures.add(dragOldParent);
      } 
    } 
  }
  
  private void transferUnit(StructurePOJO dragEntity, StructurePOJO dragNewParentEntity, String newCode, List<StructurePOJO> structureEntityList, List<BasicPOJO> basicEntityList, List<DeptPOJO> deptEntityList, List<PosPOJO> posEntityList, List<StaffEntity> staffEntityList, List<PartTimeJob> partTimeJobEntityList, List<StructurePOJO> updateStructures, List<StructurePOJO> updateStructureList, List<BasicPOJO> updateUnits, List<DeptPOJO> updateDepts, List<PosPOJO> updatePos, List<StaffEntity> updateStaffs, List<PartTimeJob> updatePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePartJobPair> updatePartTimeJobPublishList, List<UpdateOrgDataPair> orgDataChangedPublishList) {
    dragNewParentEntity.setChildrenId(dragEntity.getUuid());
    StructurePOJO oldDragEntity = (StructurePOJO)EntityUtil.copySimilar(dragEntity, StructurePOJO.class);
    String oldCode = oldDragEntity.getOrgCode();
    Map<String, StructurePOJO> orgId_unitStrtuct = new HashMap<>();
    Map<String, StructurePOJO> orgId_deptStruct = new HashMap<>();
    Map<String, StructurePOJO> orgId_posStruct = new HashMap<>();
    List<StructurePOJO> childStructs = CollectionHelper.filter(structureEntityList, s -> s.getOrgCode().startsWith(oldCode));
    childStructs.removeIf(cs -> StringUtils.equals(dragEntity.getUuid(), cs.getUuid()));
    dragEntity.setOrgCode(newCode);
    dragEntity.setParentId(dragNewParentEntity.getUuid());
    orgId_unitStrtuct.put(dragEntity.getOrgId(), dragEntity);
    orgDataChangedPublishList.add(new UpdateOrgDataPair(oldDragEntity, dragEntity));
    for (StructurePOJO s : childStructs) {
      String oc = s.getOrgCode();
      String nc = oc.replaceFirst(oldCode, newCode);
      s.setOrgCode(nc);
      if (s.getOrgType().intValue() == 1) {
        orgId_unitStrtuct.put(s.getOrgId(), s);
        continue;
      } 
      if (s.getOrgType().intValue() == 2) {
        orgId_deptStruct.put(s.getOrgId(), s);
        continue;
      } 
      if (s.getOrgType().intValue() == 3)
        orgId_posStruct.put(s.getOrgId(), s); 
    } 
    List<BasicPOJO> units = CollectionHelper.filter(basicEntityList, b -> b.getCode().startsWith(oldCode));
    for (BasicPOJO b : units) {
      StructurePOJO us = orgId_unitStrtuct.get(b.getUuid());
      b.setCode(us.getOrgCode());
      if (!b.getUuid().equals(dragEntity.getOrgId()))
        continue; 
      b.setParentId(dragNewParentEntity.getOrgId());
    } 
    List<DeptPOJO> depts = CollectionHelper.filter(deptEntityList, b -> b.getCode().startsWith(oldCode));
    for (DeptPOJO b : depts) {
      StructurePOJO us = orgId_deptStruct.get(b.getUuid());
      b.setCode(us.getOrgCode());
    } 
    List<PosPOJO> posses = CollectionHelper.filter(posEntityList, b -> b.getCode().startsWith(oldCode));
    for (PosPOJO p : posses) {
      StructurePOJO us = orgId_posStruct.get(p.getUuid());
      p.setCode(us.getOrgCode());
    } 
    List<StaffEntity> unitStaffs = CollectionHelper.filter(staffEntityList, s -> StringUtils.isBlank(s.getUnitCode()) ? false : s.getUnitCode().startsWith(oldCode));
    for (StaffEntity s : unitStaffs) {
      StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(s, StaffEntity.class);
      StructurePOJO us = orgId_unitStrtuct.get(s.getUnitId());
      s.setUnitCode(us.getOrgCode());
      StructurePOJO ds = orgId_deptStruct.get(s.getDeptId());
      String deptCode = "";
      if (ds == null) {
        System.out.println("");
      } else {
        deptCode = ds.getOrgCode();
      } 
      s.setDeptCode(deptCode);
      StructurePOJO ps = orgId_posStruct.get(s.getPosId());
      String posCode = ps.getOrgCode();
      s.setPosCode(posCode);
      updateStaffPublishList.add(new UpdatePair(oldStaffEntity, s));
    } 
    List<PartTimeJob> unitPartTimeJobs = CollectionHelper.filter(partTimeJobEntityList, s -> StringUtils.isBlank(s.getUnitCode()) ? false : s.getUnitCode().startsWith(oldCode));
    for (PartTimeJob s : unitPartTimeJobs) {
      PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(s, PartTimeJob.class);
      StructurePOJO us = orgId_unitStrtuct.get(s.getUnitId());
      s.setUnitCode(us.getOrgCode());
      StructurePOJO ds = orgId_deptStruct.get(s.getDeptId());
      String deptCode = ds.getOrgCode();
      s.setDeptCode(deptCode);
      StructurePOJO ps = orgId_posStruct.get(s.getPosId());
      String posCode = "";
      if (ps == null) {
        System.out.println("");
      } else {
        posCode = ps.getOrgCode();
      } 
      s.setPosCode(posCode);
      updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, s));
    } 
    updateStructures.add(dragEntity);
    updateStructures.add(dragNewParentEntity);
    updateStructures.addAll(childStructs);
    updateStructureList.add(dragEntity);
    updateStructureList.addAll(childStructs);
    updateUnits.addAll(units);
    updateDepts.addAll(depts);
    updatePos.addAll(posses);
    updateStaffs.addAll(unitStaffs);
    updatePartTimeJobs.addAll(unitPartTimeJobs);
  }
  
  private void transferDept(StructurePOJO dragEntity, StructurePOJO dragNewParentEntity, String newCode, List<StructurePOJO> structureEntityList, List<DeptPOJO> deptEntityList, List<PosPOJO> posEntityList, List<StaffEntity> staffEntityList, List<PartTimeJob> partTimeJobEntityList, List<StructurePOJO> updateStructures, List<StructurePOJO> updateStructureList, List<DeptPOJO> updateDepts, List<PosPOJO> updatePos, List<StaffEntity> updateStaffs, List<PartTimeJob> updatePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePartJobPair> updatePartTimeJobPublishList, List<UpdateOrgDataPair> orgDataChangedPublishList) {
    dragNewParentEntity.setChildrenId(dragEntity.getUuid());
    DeptPOJO dragDeptEntity = (DeptPOJO)CollectionHelper.get(deptEntityList, d -> StringUtils.equals(d.getUuid(), dragEntity.getOrgId()));
    StructurePOJO oldDragEntity = (StructurePOJO)EntityUtil.copySimilar(dragEntity, StructurePOJO.class);
    String oldCode = oldDragEntity.getOrgCode();
    String newUnitId = null;
    String newUnitCode = null;
    String newUnitName = null;
    boolean moveToDept = (dragNewParentEntity.getOrgType().intValue() == 2);
    if (moveToDept) {
      DeptPOJO dragNewParentDeptEntity = (DeptPOJO)CollectionHelper.get(deptEntityList, d -> StringUtils.equals(d.getUuid(), dragNewParentEntity.getOrgId()));
      StructurePOJO newUnitStruct = (StructurePOJO)CollectionHelper.get(structureEntityList, s -> (s.getOrgType().intValue() == 1 && StringUtils.equals(s.getOrgId(), dragNewParentDeptEntity.getUnitId())));
      newUnitId = newUnitStruct.getOrgId();
      newUnitCode = newUnitStruct.getOrgCode();
      newUnitName = newUnitStruct.getOrgName();
      dragDeptEntity.setUnitId(newUnitId);
      dragDeptEntity.setParentDept(dragNewParentEntity.getOrgId());
    } else {
      newUnitId = dragNewParentEntity.getOrgId();
      newUnitCode = dragNewParentEntity.getOrgCode();
      newUnitName = dragNewParentEntity.getOrgName();
      dragDeptEntity.setUnitId(newUnitId);
      dragDeptEntity.setParentDept(null);
    } 
    List<DeptPOJO> childDepts = CollectionHelper.filter(deptEntityList, d -> d.getCode().startsWith(oldCode));
    List<StructurePOJO> childDeptStructs = CollectionHelper.filter(structureEntityList, s -> (s.getOrgType().intValue() == 2 && s.getOrgCode().startsWith(oldCode)));
    childDeptStructs.removeIf(cs -> StringUtils.equals(dragEntity.getUuid(), cs.getUuid()));
    List<PosPOJO> poses = CollectionHelper.filter(posEntityList, p -> p.getCode().startsWith(oldCode));
    List<StructurePOJO> posStructs = CollectionHelper.filter(structureEntityList, s -> (s.getOrgType().intValue() == 3 && s.getOrgCode().startsWith(oldCode)));
    Map<String, StructurePOJO> orgId_struct = CollectionHelper.mapDict(childDeptStructs, ds -> ds.getOrgId());
    Map<String, StructurePOJO> orgId_posStruct = CollectionHelper.mapDict(posStructs, ds -> ds.getOrgId());
    List<StaffEntity> childStaffs = CollectionHelper.filter(staffEntityList, s -> StringUtils.isBlank(s.getDeptCode()) ? false : s.getDeptCode().startsWith(oldCode));
    Map<String, List<StaffEntity>> deptId_staffs = CollectionHelper.mapListDict(childStaffs, s -> s.getDeptId());
    Map<String, List<StaffEntity>> posId_staffs = CollectionHelper.mapListDict(childStaffs, s -> s.getPosId());
    List<PartTimeJob> childPartTimeJobs = CollectionHelper.filter(partTimeJobEntityList, s -> StringUtils.isBlank(s.getDeptCode()) ? false : s.getDeptCode().startsWith(oldCode));
    Map<String, List<PartTimeJob>> deptId_partTimeJobs = CollectionHelper.mapListDict(childPartTimeJobs, s -> s.getDeptId());
    Map<String, List<PartTimeJob>> posId_partTimeJobs = CollectionHelper.mapListDict(childPartTimeJobs, s -> s.getPosId());
    dragEntity.setOrgCode(newCode);
    dragEntity.setParentId(dragNewParentEntity.getUuid());
    orgDataChangedPublishList.add(new UpdateOrgDataPair(oldDragEntity, dragEntity));
    for (DeptPOJO d : childDepts) {
      String deptCode = d.getCode();
      String newChildCode = deptCode.replaceFirst(oldCode, newCode);
      d.setCode(newChildCode);
      d.setUnitId(newUnitId);
      if (!deptCode.equals(oldCode)) {
        StructurePOJO ds = orgId_struct.get(d.getUuid());
        ds.setOrgCode(newChildCode);
      } 
      List<StaffEntity> dstaffs = deptId_staffs.get(d.getUuid());
      if (dstaffs != null)
        for (StaffEntity s : dstaffs) {
          StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(s, StaffEntity.class);
          s.setDeptCode(newChildCode);
          s.setUnitId(newUnitId);
          s.setUnitCode(newUnitCode);
          s.setUnitName(newUnitName);
          updateStaffPublishList.add(new UpdatePair(oldStaffEntity, s));
        }  
      List<PartTimeJob> dPartTimeJobs = deptId_partTimeJobs.get(d.getUuid());
      if (dPartTimeJobs != null)
        for (PartTimeJob s : dPartTimeJobs) {
          PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(s, PartTimeJob.class);
          s.setDeptCode(newChildCode);
          s.setUnitId(newUnitId);
          s.setUnitCode(newUnitCode);
          s.setUnitName(newUnitName);
          updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, s));
        }  
    } 
    for (PosPOJO p : poses) {
      String newPosCode = p.getCode().replaceFirst(oldCode, newCode);
      p.setCode(newPosCode);
      p.setUnitId(newUnitId);
      StructurePOJO ps = orgId_posStruct.get(p.getUuid());
      ps.setOrgCode(newPosCode);
      List<StaffEntity> dstaffs = posId_staffs.get(p.getUuid());
      if (dstaffs != null)
        for (StaffEntity s : dstaffs) {
          StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(s, StaffEntity.class);
          s.setPosCode(newPosCode);
          s.setUnitId(newUnitId);
          s.setUnitCode(newUnitCode);
          s.setUnitName(newUnitName);
          updateStaffPublishList.add(new UpdatePair(oldStaffEntity, s));
        }  
      List<PartTimeJob> pPartTimeJobs = posId_partTimeJobs.get(p.getUuid());
      if (pPartTimeJobs != null)
        for (PartTimeJob s : pPartTimeJobs) {
          PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(s, PartTimeJob.class);
          s.setPosCode(newPosCode);
          s.setUnitId(newUnitId);
          s.setUnitCode(newUnitCode);
          s.setUnitName(newUnitName);
          updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, s));
        }  
    } 
    updateStructures.add(dragEntity);
    updateStructures.add(dragNewParentEntity);
    updateStructureList.add(dragEntity);
    updateDepts.add(dragDeptEntity);
    updateStructures.addAll(childDeptStructs);
    updateStructureList.addAll(childDeptStructs);
    updateDepts.addAll(childDepts);
    updateStructures.addAll(posStructs);
    updateStructureList.addAll(posStructs);
    updatePos.addAll(poses);
    updateStaffs.addAll(childStaffs);
    updatePartTimeJobs.addAll(childPartTimeJobs);
  }
  
  private void transferPos(StructurePOJO dragEntity, StructurePOJO dragNewParentEntity, String newCode, List<StructurePOJO> structureEntityList, List<DeptPOJO> deptEntityList, List<PosPOJO> posEntityList, List<StaffEntity> staffEntityList, List<PartTimeJob> partTimeJobEntityList, List<StructurePOJO> updateStructures, List<StructurePOJO> updateStructureList, List<PosPOJO> updatePos, List<StaffEntity> updateStaffs, List<PartTimeJob> updatePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePartJobPair> updatePartTimeJobPublishList, List<UpdateOrgDataPair> orgDataChangedPublishList) {
    dragNewParentEntity.setChildrenId(dragEntity.getUuid());
    StructurePOJO oldStructurePOJO = (StructurePOJO)EntityUtil.copySimilar(dragEntity, StructurePOJO.class);
    dragEntity.setParentId(dragNewParentEntity.getUuid());
    dragEntity.setOrgCode(newCode);
    orgDataChangedPublishList.add(new UpdateOrgDataPair(oldStructurePOJO, dragEntity));
    PosPOJO dragPosEntity = (PosPOJO)CollectionHelper.get(posEntityList, d -> StringUtils.equals(d.getUuid(), dragEntity.getOrgId()));
    DeptPOJO dragNewParentDeptEntity = (DeptPOJO)CollectionHelper.get(deptEntityList, d -> StringUtils.equals(d.getUuid(), dragNewParentEntity.getOrgId()));
    StructurePOJO newUnitStruct = (StructurePOJO)CollectionHelper.get(structureEntityList, s -> (s.getOrgType().intValue() == 1 && StringUtils.equals(s.getOrgId(), dragNewParentDeptEntity.getUnitId())));
    dragPosEntity.setUnitId(newUnitStruct.getOrgId());
    dragPosEntity.setDeptId(dragNewParentDeptEntity.getUuid());
    dragPosEntity.setCode(newCode);
    List<StaffEntity> posStaffs = CollectionHelper.filter(staffEntityList, s -> StringUtils.equals(s.getPosId(), dragPosEntity.getUuid()));
    if (posStaffs != null)
      for (StaffEntity s : posStaffs) {
        StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(s, StaffEntity.class);
        s.setPosCode(newCode);
        s.setUnitId(newUnitStruct.getOrgId());
        s.setUnitName(newUnitStruct.getName());
        s.setUnitCode(newUnitStruct.getOrgCode());
        s.setDeptId(dragNewParentDeptEntity.getUuid());
        s.setDeptName(dragNewParentDeptEntity.getName());
        s.setDeptCode(dragNewParentDeptEntity.getCode());
        updateStaffPublishList.add(new UpdatePair(oldStaffEntity, s));
      }  
    List<PartTimeJob> posPartTimeJobs = CollectionHelper.filter(partTimeJobEntityList, s -> StringUtils.equals(s.getPosId(), dragPosEntity.getUuid()));
    if (posPartTimeJobs != null)
      for (PartTimeJob s : posPartTimeJobs) {
        PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(s, PartTimeJob.class);
        s.setPosCode(newCode);
        s.setUnitId(newUnitStruct.getOrgId());
        s.setUnitName(newUnitStruct.getName());
        s.setUnitCode(newUnitStruct.getOrgCode());
        s.setDeptId(dragNewParentDeptEntity.getUuid());
        s.setDeptName(dragNewParentDeptEntity.getName());
        s.setDeptCode(dragNewParentDeptEntity.getCode());
        updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, s));
      }  
    updateStructures.add(dragNewParentEntity);
    updateStructures.add(dragEntity);
    updateStructureList.add(dragEntity);
    updatePos.add(dragPosEntity);
    updateStaffs.addAll(posStaffs);
    updatePartTimeJobs.addAll(posPartTimeJobs);
  }
  
  public void autoSyncUpdateStr(Map<String, RecyclePOJO> recyclePOJOMap, List<StructurePOJO> allHjStructures, List<BasicPOJO> allUnits, List<DeptPOJO> allDepts, List<PosPOJO> allPoses, List<StaffEntity> allStaffs, List<PartTimeJob> allPartTimeJobs, List<StrSuppose> allZxbcOrgs, List<StructurePOJO> updateStructures, List<StructurePOJO> updateStructureList, List<BasicPOJO> updateUnits, List<DeptPOJO> updateDepts, List<PosPOJO> updatePos, List<StaffEntity> updateStaffs, List<PartTimeJob> updatePartTimeJobs, List<UpdatePair> updateStaffPublishList, List<UpdatePartJobPair> updatePartTimeJobPublishList, List<UpdateOrgPair> orgInfoChangedPublishList) {
    List<String> zxbcAllIds = CollectionHelper.extractToList(allZxbcOrgs, a -> a.getOrgId());
    Map<String, StrSuppose> zgtjIdAndZgtjOrgMap = CollectionHelper.mapDict(allZxbcOrgs, a -> a.getOrgId());
    Map<String, StructurePOJO> zxbcIdAndStructureMap = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    List<String> deleteRecycleObids = new ArrayList<>();
    for (String zxbcId : zxbcAllIds) {
      StructurePOJO updateStructurePOJO = zxbcIdAndStructureMap.get(String.valueOf(zxbcId));
      StrSuppose orgMatchEntity = zgtjIdAndZgtjOrgMap.get(zxbcId);
      if (updateStructurePOJO != null && (
        !updateStructurePOJO.getOrgName().equals(orgMatchEntity.getC_name()) || (orgMatchEntity.getDeleteFlag().equals("1") && updateStructurePOJO.getDeleteFlag().booleanValue()))) {
        String newName = orgMatchEntity.getC_name();
        if (updateStructurePOJO.getOrgType().intValue() == 1) {
          updateStructurePOJO.setOrgName(newName);
          BasicPOJO updateBasicPOJO = (BasicPOJO)CollectionHelper.get(allUnits, a -> StringUtils.equals(a.getUuid(), updateStructurePOJO.getOrgId()));
          updateBasicPOJO.setName(newName);
          if (orgMatchEntity.getDeleteFlag().equals("1") && updateStructurePOJO.getDeleteFlag().booleanValue()) {
            updateStructurePOJO.setDeleteFlag(Boolean.valueOf(false));
            updateBasicPOJO.setDeleteFlag(Boolean.valueOf(false));
            if (recyclePOJOMap.get(updateStructurePOJO.getUuid()) != null)
              deleteRecycleObids.add(updateStructurePOJO.getUuid()); 
          } 
          List<StaffEntity> updateStaffList = CollectionHelper.filter(allStaffs, a -> StringUtils.equals(a.getUnitId(), updateStructurePOJO.getOrgId()));
          for (StaffEntity updateStaff : updateStaffList) {
            StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(updateStaff, StaffEntity.class);
            updateStaff.setUnitName(newName);
            updateStaffPublishList.add(new UpdatePair(oldStaffEntity, updateStaff));
          } 
          List<PartTimeJob> updatePartTimeJobList = CollectionHelper.filter(allPartTimeJobs, a -> StringUtils.equals(a.getUnitId(), updateStructurePOJO.getOrgId()));
          for (PartTimeJob updatePartTimeJob : updatePartTimeJobList) {
            PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(updatePartTimeJob, PartTimeJob.class);
            updatePartTimeJob.setUnitName(newName);
            updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, updatePartTimeJob));
          } 
          updateStructures.add(updateStructurePOJO);
          updateStructureList.add(updateStructurePOJO);
          updateUnits.add(updateBasicPOJO);
          updateStaffs.addAll(updateStaffList);
          updatePartTimeJobs.addAll(updatePartTimeJobList);
        } else if (updateStructurePOJO.getOrgType().intValue() == 2) {
          updateStructurePOJO.setOrgName(newName);
          DeptPOJO updateDeptPOJO = (DeptPOJO)CollectionHelper.get(allDepts, a -> StringUtils.equals(a.getUuid(), updateStructurePOJO.getOrgId()));
          updateDeptPOJO.setName(newName);
          if (orgMatchEntity.getDeleteFlag().equals("1") && updateStructurePOJO.getDeleteFlag().booleanValue()) {
            updateStructurePOJO.setDeleteFlag(Boolean.valueOf(false));
            updateDeptPOJO.setDeleteFlag(Boolean.valueOf(false));
            if (recyclePOJOMap.get(updateStructurePOJO.getUuid()) != null)
              deleteRecycleObids.add(updateStructurePOJO.getUuid()); 
          } 
          List<StaffEntity> updateStaffList = CollectionHelper.filter(allStaffs, a -> StringUtils.equals(a.getDeptId(), updateStructurePOJO.getOrgId()));
          for (StaffEntity updateStaff : updateStaffList) {
            StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(updateStaff, StaffEntity.class);
            updateStaff.setDeptName(newName);
            updateStaffPublishList.add(new UpdatePair(oldStaffEntity, updateStaff));
          } 
          List<PartTimeJob> updatePartTimeJobList = CollectionHelper.filter(allPartTimeJobs, a -> StringUtils.equals(a.getDeptId(), updateStructurePOJO.getOrgId()));
          for (PartTimeJob updatePartTimeJob : updatePartTimeJobList) {
            PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(updatePartTimeJob, PartTimeJob.class);
            updatePartTimeJob.setDeptName(newName);
            updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, updatePartTimeJob));
          } 
          updateStructures.add(updateStructurePOJO);
          updateStructureList.add(updateStructurePOJO);
          updateDepts.add(updateDeptPOJO);
          updateStaffs.addAll(updateStaffList);
          updatePartTimeJobs.addAll(updatePartTimeJobList);
        } else if (updateStructurePOJO.getOrgType().intValue() == 3) {
          updateStructurePOJO.setOrgName(newName);
          PosPOJO updatePosPOJO = (PosPOJO)CollectionHelper.get(allPoses, a -> StringUtils.equals(a.getUuid(), updateStructurePOJO.getOrgId()));
          updatePosPOJO.setName(newName);
          if (orgMatchEntity.getDeleteFlag().equals("1") && updateStructurePOJO.getDeleteFlag().booleanValue()) {
            updateStructurePOJO.setDeleteFlag(Boolean.valueOf(false));
            updatePosPOJO.setDeleteFlag(Boolean.valueOf(false));
            if (recyclePOJOMap.get(updateStructurePOJO.getUuid()) != null)
              deleteRecycleObids.add(updateStructurePOJO.getUuid()); 
          } 
          List<StaffEntity> updateStaffList = CollectionHelper.filter(allStaffs, a -> StringUtils.equals(a.getPosId(), updateStructurePOJO.getOrgId()));
          for (StaffEntity updateStaff : updateStaffList) {
            StaffEntity oldStaffEntity = (StaffEntity)EntityUtil.copySimilar(updateStaff, StaffEntity.class);
            updateStaff.setPosName(newName);
            updateStaffPublishList.add(new UpdatePair(oldStaffEntity, updateStaff));
          } 
          List<PartTimeJob> updatePartTimeJobList = CollectionHelper.filter(allPartTimeJobs, a -> StringUtils.equals(a.getPosId(), updateStructurePOJO.getOrgId()));
          for (PartTimeJob updatePartTimeJob : updatePartTimeJobList) {
            PartTimeJob oldPartTimeJob = (PartTimeJob)EntityUtil.copySimilar(updatePartTimeJob, PartTimeJob.class);
            updatePartTimeJob.setPosName(newName);
            updatePartTimeJobPublishList.add(new UpdatePartJobPair(oldPartTimeJob, updatePartTimeJob));
          } 
          updateStructures.add(updateStructurePOJO);
          updateStructureList.add(updateStructurePOJO);
          updatePos.add(updatePosPOJO);
          updateStaffs.addAll(updateStaffList);
          updatePartTimeJobs.addAll(updatePartTimeJobList);
        } 
        UpdateOrgPair updateOrgPair = new UpdateOrgPair(updateStructurePOJO.getOrgName(), updateStructurePOJO.getOrgType(), updateStructurePOJO.getOrgId());
        orgInfoChangedPublishList.add(updateOrgPair);
      } 
    } 
    if (deleteRecycleObids.size() > 0)
      this.recycleService.deleteByObjectId(deleteRecycleObids); 
  }
  
  public void autoSyncAddStr(UserEntity tadmin, List<StructurePOJO> allHjStructures, List<BasicPOJO> allBasics, List<StrSuppose> allLjjtUnits, List<StructurePOJO> addStructures, List<BasicPOJO> addunits, List<StructurePOJO> updateStructures, List<DeptPOJO> allDepts, List<PosPOJO> allPos, List<DeptPOJO> addDepts, List<PosPOJO> addPos, Date nowDate, Date endDate) {
    List<String> ljjtAllIds = CollectionHelper.extractToList(allLjjtUnits, a -> a.getOrgId());
    Map<String, StrSuppose> zxbcIdAndDeptDto = CollectionHelper.mapDict(allLjjtUnits, a -> a.getOrgId());
    Map<String, List<StrSuppose>> zxbcParentIdAndDeptDtos = CollectionHelper.mapListDict(allLjjtUnits, a -> a.getParentid());
    Map<String, StructurePOJO> zxbcIdAndStructurePOJOMap = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgNum());
    Map<String, StructurePOJO> allUuidStructureMap = CollectionHelper.mapDict(allHjStructures, a -> a.getUuid());
    Map<String, StructurePOJO> orgIdAndStructure = CollectionHelper.mapDict(allHjStructures, a -> a.getOrgId());
    List<StructurePOJO> allHjStructuresCopy = EntityUtil.copySimilar(allHjStructures, StructurePOJO.class);
    Map<String, DeptPOJO> uuidAndDept = CollectionHelper.mapDict(allDepts, a -> a.getUuid());
    Map<String, BasicPOJO> uuidAnUnit = CollectionHelper.mapDict(allBasics, a -> a.getUuid());
    Map<String, PosPOJO> uuidAnPos = CollectionHelper.mapDict(allPos, a -> a.getUuid());
    this.logger.info("ljjtAllIds size{}", Integer.valueOf(ljjtAllIds.size()));
    List<StrSuppose> zxbcAddDeptDtos = new ArrayList<>();
    for (String ljjtId : ljjtAllIds) {
      StructurePOJO structurePOJO = zxbcIdAndStructurePOJOMap.get(String.valueOf(ljjtId));
      if (structurePOJO == null)
        zxbcAddDeptDtos.add(zxbcIdAndDeptDto.get(ljjtId)); 
    } 
    ArrayList<StrSuppose> firstDeptMatchList = new ArrayList<>();
    List<String> zxbcAddedIds = CollectionHelper.extractToList(zxbcAddDeptDtos, a -> a.getOrgId());
    for (StrSuppose strSuppose : zxbcAddDeptDtos) {
      if (!zxbcAddedIds.contains(strSuppose.getParentid()))
        firstDeptMatchList.add(strSuppose); 
    } 
    Map<String, List<StructurePOJO>> addedStructureTrees = new HashMap<>();
    Map<String, String> firstLevelIdAndTargetIdMap = new HashMap<>();
    Map<String, String> structurePidAndOrgCodeMap = new HashMap<>();
    double showorder = this.structureService.maxShowOrder(tadmin.getTenantId()).doubleValue();
    List<StructurePOJO> needUpdateParentStructures = new ArrayList<>();
    for (StrSuppose deptMatch : firstDeptMatchList) {
      String zxbcParentId = deptMatch.getParentid();
      StructurePOJO parentStructure = zxbcIdAndStructurePOJOMap.get(zxbcParentId.toString());
      if (parentStructure == null)
        continue; 
      needUpdateParentStructures.add(parentStructure);
      List<StructurePOJO> structures = new ArrayList<>();
      List<StructurePOJO> tempStructures = new ArrayList<>();
      tempStructures.add(parentStructure);
      List<StructurePOJO> templist = new ArrayList<>();
      StructurePOJO firstLevel = null;
      while (true) {
        for (int i = 0; i < tempStructures.size(); i++) {
          StructurePOJO parent = tempStructures.get(i);
          if (parent == null)
            System.out.println(); 
          if (parent.getOrgNum().equals("2599"))
            System.out.println(""); 
          List<StrSuppose> deptList = zxbcParentIdAndDeptDtos.get(parent.getOrgNum());
          if (deptList != null) {
            int code = 1;
            for (StrSuppose orgMatch : deptList) {
              if (orgMatch.getOrgId().equals("2599"))
                System.out.println(""); 
              if (orgMatch.getOrgId().equals("p1347"))
                System.out.println(); 
              if (parentStructure.getUuid().equals(parent.getUuid())) {
                if (!deptMatch.getOrgId().equals(orgMatch.getOrgId()))
                  continue; 
                StructurePOJO structurePOJO = null;
                BasicPOJO basicEntity = null;
                DeptPOJO deptEntity = null;
                PosPOJO posEntity = null;
                if (orgMatch.getType().equals(StrSuppose.TYPE_UNIT)) {
                  structurePOJO = packStructureBasic(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                  basicEntity = packBasic(structurePOJO);
                  structurePOJO.setOrgId(basicEntity.getUuid());
                  uuidAnUnit.put(basicEntity.getUuid(), basicEntity);
                  addunits.add(basicEntity);
                } else if (orgMatch.getType().equals(StrSuppose.TYPE_DEPT)) {
                  structurePOJO = packStructureDept(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                  String unitId = null;
                  if (parent.getOrgType().intValue() == 1) {
                    unitId = parent.getOrgId();
                  } else if (parent.getOrgType().intValue() == 2) {
                    unitId = ((DeptPOJO)uuidAndDept.get(parent.getOrgId())).getUnitId();
                  } 
                  if (unitId == null)
                    System.out.println(); 
                  deptEntity = packDept(structurePOJO, unitId, parent);
                  structurePOJO.setOrgId(deptEntity.getUuid());
                  addDepts.add(deptEntity);
                  uuidAndDept.put(deptEntity.getUuid(), deptEntity);
                } else if (orgMatch.getType().equals(StrSuppose.TYPE_POS)) {
                  structurePOJO = packStructurePos(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                  if (uuidAndDept.get(parent.getOrgId()) == null)
                    System.out.println(); 
                  String unitId = "";
                  String deptId = parent.getOrgId();
                  if (parent.getOrgType().intValue() == 1) {
                    unitId = parent.getOrgId();
                    deptId = null;
                  } else if (parent.getOrgType().intValue() == 2) {
                    unitId = ((DeptPOJO)uuidAndDept.get(parent.getOrgId())).getUnitId();
                  } 
                  if (unitId == null)
                    System.out.println(); 
                  posEntity = packPos(structurePOJO, unitId, deptId);
                  structurePOJO.setOrgId(posEntity.getUuid());
                  addPos.add(posEntity);
                  uuidAnPos.put(posEntity.getUuid(), posEntity);
                } 
                if (basicEntity != null)
                  basicEntity.setCode(structurePOJO.getOrgCode()); 
                if (deptEntity != null)
                  deptEntity.setCode(structurePOJO.getOrgCode()); 
                if (posEntity != null)
                  posEntity.setCode(structurePOJO.getOrgCode()); 
                parent.setChildrenId(structurePOJO.getUuid());
                allUuidStructureMap.put(structurePOJO.getUuid(), structurePOJO);
                orgIdAndStructure.put(structurePOJO.getOrgId(), structurePOJO);
                zxbcIdAndStructurePOJOMap.put(structurePOJO.getOrgNum(), structurePOJO);
                templist.add(structurePOJO);
                firstLevel = structurePOJO;
                continue;
              } 
              if (!zxbcAddedIds.contains(orgMatch.getOrgId()))
                continue; 
              StructurePOJO structureEntity = null;
              if (orgMatch.getType().equals(StrSuppose.TYPE_UNIT)) {
                structureEntity = packStructureBasic(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                BasicPOJO basicEntity = packBasic(structureEntity);
                structureEntity.setOrgId(basicEntity.getUuid());
                basicEntity.setParentId(parent.getOrgId());
                addunits.add(basicEntity);
                uuidAnUnit.put(basicEntity.getUuid(), basicEntity);
              } else if (orgMatch.getType().equals(StrSuppose.TYPE_DEPT)) {
                structureEntity = packStructureDept(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                String unitId = null;
                if (parent.getOrgType().intValue() == 1) {
                  unitId = parent.getOrgId();
                } else if (parent.getOrgType().intValue() == 2) {
                  unitId = ((DeptPOJO)uuidAndDept.get(parent.getOrgId())).getUnitId();
                } 
                if (unitId == null)
                  System.out.println(); 
                DeptPOJO deptEntity = packDept(structureEntity, unitId, parent);
                structureEntity.setOrgId(deptEntity.getUuid());
                addDepts.add(deptEntity);
                uuidAndDept.put(deptEntity.getUuid(), deptEntity);
              } else if (orgMatch.getType().equals(StrSuppose.TYPE_POS)) {
                structureEntity = packStructurePos(orgMatch, parent, tadmin, String.valueOf(code), 0.0D, nowDate, endDate, allHjStructuresCopy);
                String unitId = "";
                if (uuidAndDept.get(parent.getOrgId()) != null) {
                  unitId = ((DeptPOJO)uuidAndDept.get(parent.getOrgId())).getUnitId();
                } else {
                  unitId = ((BasicPOJO)uuidAnUnit.get(parent.getOrgId())).getUuid();
                } 
                if (unitId == null)
                  System.out.println(); 
                String deptId = parent.getOrgId();
                if (parent.getOrgType().intValue() == 1)
                  deptId = null; 
                PosPOJO posEntity = packPos(structureEntity, unitId, deptId);
                structureEntity.setOrgId(posEntity.getUuid());
                addPos.add(posEntity);
                uuidAnPos.put(posEntity.getUuid(), posEntity);
              } 
              code++;
              parent.setChildrenId(structureEntity.getUuid());
              templist.add(structureEntity);
              allUuidStructureMap.put(structureEntity.getUuid(), structureEntity);
              orgIdAndStructure.put(structureEntity.getOrgId(), structureEntity);
              zxbcIdAndStructurePOJOMap.put(structureEntity.getOrgNum(), structureEntity);
            } 
          } 
        } 
        tempStructures.clear();
        if (templist.isEmpty())
          break; 
        structures.addAll(templist);
        tempStructures.addAll(templist);
        templist.clear();
      } 
      if (firstLevel == null)
        System.out.println(); 
      addedStructureTrees.put(firstLevel.getUuid(), structures);
      firstLevelIdAndTargetIdMap.put(firstLevel.getUuid(), parentStructure.getUuid());
    } 
    Map<String, Double> structurePidAndShowOrderMap = new HashMap<>();
    for (String structureId : addedStructureTrees.keySet()) {
      List<StructurePOJO> structureEntityList = addedStructureTrees.get(structureId);
      Collections.sort(structureEntityList, (Comparator<? super StructurePOJO>)new Object(this));
      StructurePOJO targetEntity = allUuidStructureMap.get(firstLevelIdAndTargetIdMap.get(structureId));
      Double showOrderMark = this.structureService.getShowOrderMark(tadmin.getTenantId(), targetEntity, structureEntityList.size());
      Double maxOrder = Double.valueOf(0.0D);
      if (structurePidAndShowOrderMap.get(targetEntity.getUuid()) != null) {
        maxOrder = structurePidAndShowOrderMap.get(targetEntity.getUuid());
      } else {
        maxOrder = this.structureService.getAutoShowOrder(targetEntity.getOrgCode() + "%", tadmin.getTenantId());
      } 
      if (maxOrder == null)
        maxOrder = Double.valueOf(0.0D); 
      for (StructurePOJO structureEntity : structureEntityList) {
        maxOrder = Double.valueOf(maxOrder.doubleValue() + showOrderMark.doubleValue());
        structurePidAndShowOrderMap.put(targetEntity.getUuid(), maxOrder);
        structureEntity.setShowOrder(maxOrder);
        if (structureEntity.getOrgType().equals(Integer.valueOf(ZgtjOrgMatchEntity.TYPE_UNIT))) {
          BasicPOJO basicEntity = uuidAnUnit.get(structureEntity.getOrgId());
          basicEntity.setShowOrder(maxOrder);
        } else if (structureEntity.getOrgType().equals(Integer.valueOf(ZgtjOrgMatchEntity.TYPE_DEPT))) {
          DeptPOJO deptEntity = uuidAndDept.get(structureEntity.getOrgId());
          deptEntity.setShowOrder(maxOrder);
        } else if (structureEntity.getOrgType().equals(Integer.valueOf(ZgtjOrgMatchEntity.TYPE_POS))) {
          PosPOJO posEntity = uuidAnPos.get(structureEntity.getOrgId());
          posEntity.setShowOrder(maxOrder);
        } 
        addStructures.add(structureEntity);
        allUuidStructureMap.put(structureEntity.getUuid(), structureEntity);
        zxbcIdAndStructurePOJOMap.put(structureEntity.getOrgNum(), structureEntity);
      } 
    } 
    this.logger.info("addstr size{}", Integer.valueOf(addStructures.size()));
    allHjStructures.addAll(addStructures);
    allBasics.addAll(addunits);
    this.logger.info("allBasics size{}", Integer.valueOf(addunits.size()));
    this.logger.info("allBasics size{}", Integer.valueOf(addDepts.size()));
    this.logger.info("allBasics size{}", Integer.valueOf(addPos.size()));
    updateStructures.addAll(needUpdateParentStructures);
  }
  
  private StructurePOJO packStructureDept(StrSuppose strSuppose, StructurePOJO parent, UserEntity user, String startCode, double showorder, Date nowDate, Date endDate, List<StructurePOJO> allHjStructures) {
    StructurePOJO structure = new StructurePOJO();
    structure.setUuid(Identities.uuid2());
    structure.setStatus("1");
    structure.setCreateTs(nowDate);
    structure.setCreator(user.getUuid());
    String code = OrgUtils.getAutoCode(allHjStructures, parent.getOrgId(), parent);
    structure.setOrgCode(code);
    structure.setOrgName(strSuppose.getC_name());
    structure.setOrgType(Integer.valueOf(2));
    structure.setShowOrder(Double.valueOf(showorder));
    structure.setTenantId(user.getTenantId());
    structure.setParent(parent);
    structure.setParentId(parent.getUuid());
    structure.setOrgNum(String.valueOf(strSuppose.getOrgId()));
    structure.setStartDate(nowDate);
    structure.setEndDate(endDate);
    allHjStructures.add(structure);
    return structure;
  }
  
  private BasicPOJO packBasic(StructurePOJO structureEntity) {
    BasicPOJO basic = new BasicPOJO();
    basic.setUuid(Identities.uuid2());
    basic.setStatus("1");
    basic.setCode(structureEntity.getOrgCode());
    basic.setName(structureEntity.getName());
    basic.setShowOrder(structureEntity.getShowOrder());
    basic.setTenantId(structureEntity.getTenantId());
    basic.setStartDate(structureEntity.getStartDate());
    basic.setEndDate(structureEntity.getEndDate());
    basic.setOrgNum(String.valueOf(structureEntity.getOrgNum()));
    basic.setCreateTs(structureEntity.getCreateTs());
    basic.setCreator(structureEntity.getCreator());
    basic.setParentId(structureEntity.getParent().getOrgId());
    return basic;
  }
  
  private StructurePOJO packStructureBasic(StrSuppose strSuppose, StructurePOJO parent, UserEntity loginUser, String startCode, double showorder, Date nowDate, Date endDate, List<StructurePOJO> allHjStructures) {
    StructurePOJO structure = new StructurePOJO();
    structure.setUuid(Identities.uuid2());
    structure.setStatus("1");
    structure.setCreateTs(nowDate);
    structure.setCreator(loginUser.getUuid());
    if (parent == null) {
      structure.setOrgCode(startCode);
      structure.setShowOrder(Double.valueOf(1.0D));
    } else {
      String code = OrgUtils.getAutoCode(allHjStructures, parent.getOrgId(), parent);
      structure.setOrgCode(code);
      structure.setShowOrder(Double.valueOf(showorder));
      structure.setParentId(parent.getUuid());
    } 
    structure.setOrgName(strSuppose.getC_name());
    structure.setOrgType(Integer.valueOf(1));
    structure.setTenantId(loginUser.getTenantId());
    structure.setStartDate(nowDate);
    structure.setEndDate(endDate);
    structure.setParent(parent);
    structure.setOrgNum(String.valueOf(strSuppose.getOrgId()));
    allHjStructures.add(structure);
    return structure;
  }
  
  public DeptPOJO packDept(StructurePOJO structureEntity, String unitId, StructurePOJO parentStr) {
    DeptPOJO deptEntity = new DeptPOJO();
    deptEntity.setUuid(Identities.uuid2());
    deptEntity.setStatus(structureEntity.getStatus());
    deptEntity.setCreateTs(structureEntity.getCreateTs());
    deptEntity.setCreator(structureEntity.getCreator());
    deptEntity.setCode(structureEntity.getOrgCode());
    deptEntity.setEndDate(structureEntity.getEndDate());
    deptEntity.setName(structureEntity.getOrgName());
    if (!structureEntity.getParent().getOrgCode().equals("100") && 
      parentStr.getOrgType().intValue() == 2)
      deptEntity.setParentDept(structureEntity.getParent().getOrgId()); 
    deptEntity.setShowOrder(structureEntity.getShowOrder());
    deptEntity.setStartDate(structureEntity.getStartDate());
    deptEntity.setUnitId(unitId);
    deptEntity.setTenantId(structureEntity.getTenantId());
    deptEntity.setDeleteFlag(structureEntity.getDeleteFlag());
    deptEntity.setOrgNum(structureEntity.getOrgNum());
    return deptEntity;
  }
  
  private StructurePOJO packStructurePos(StrSuppose strSuppose, StructurePOJO parent, UserEntity loginUser, String startCode, double showorder, Date nowDate, Date endDate, List<StructurePOJO> allcopy) {
    StructurePOJO structure = new StructurePOJO();
    structure.setUuid(Identities.uuid2());
    structure.setStatus("1");
    structure.setCreateTs(nowDate);
    structure.setCreator(loginUser.getUuid());
    String code = OrgUtils.getAutoCode(allcopy, parent.getOrgId(), parent);
    structure.setOrgCode(code);
    structure.setOrgName(strSuppose.getC_name());
    if (strSuppose.getOrgId().equals("2512") || strSuppose.getOrgId().equals("2511") || strSuppose.getOrgId().equals("5262"))
      System.out.println(); 
    structure.setOrgType(Integer.valueOf(3));
    structure.setShowOrder(Double.valueOf(showorder));
    structure.setTenantId(loginUser.getTenantId());
    structure.setParent(parent);
    structure.setParentId(parent.getUuid());
    structure.setStartDate(nowDate);
    structure.setEndDate(endDate);
    structure.setOrgNum(String.valueOf(strSuppose.getOrgId()));
    allcopy.add(structure);
    return structure;
  }
  
  private PosPOJO packPos(StructurePOJO structureEntity, String unitId, String deptId) {
    PosPOJO pos = new PosPOJO();
    pos.setUuid(Identities.uuid2());
    pos.setStatus("1");
    pos.setCode(structureEntity.getOrgCode());
    pos.setDeptId(deptId);
    pos.setEndDate(structureEntity.getEndDate());
    pos.setName(structureEntity.getName());
    pos.setShowOrder(structureEntity.getShowOrder());
    pos.setUnitId(unitId);
    pos.setTenantId(structureEntity.getTenantId());
    pos.setCreateTs(structureEntity.getCreateTs());
    pos.setCreator(structureEntity.getCreator());
    pos.setStartDate(structureEntity.getStartDate());
    pos.setOrgNum(structureEntity.getOrgNum());
    return pos;
  }
}
